<?php
/**
 * @package TinyPortal
 * @version 1.0
 * @author IchBin - http://www.tinyportal.net
 * @founder Bloc
 * @license MPL 2.0
 *
 * The contents of this file are subject to the Mozilla Public License Version 2.0
 * (the "License"); you may not use this package except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Copyright (C) 2012 - The TinyPortal Team
 *
 */

if (!defined('SMF'))
	die('Hacking attempt...');


// TinyPortal init
function TPortal_init()
{
	global $maintenance, $db_prefix, $context, $scripturl,$txt , $user_info, $settings , $modSettings, $ID_MEMBER, $boarddir, $boardurl, $sourcedir, $forum_version;

	// has init been run before? if so return!
	if(isset($context['TPortal']['fixed_width']))
		return;

	// go back on showing attachments..
	if(isset($_GET['action']) && $_GET['action']=='dlattach')
		return;

	require_once($boarddir. '/SSI.php');
	
	// prefix of the TP tables
	$tp_prefix = $db_prefix.'tp_'; 
	$settings['tp_prefix'] = $tp_prefix;
	$settings['tp_smfversion'] = '1';
	$context['TPortal'] = array();
	$context['TPortal']['querystring'] = $_SERVER['QUERY_STRING'];
	// include the common files.
	require_once($sourcedir.'/TPSubs.php');
	$context['session_var'] = 'sesc';
	$modSettings['global_character_set'] = 'utf-8';

	setupTPsettings();
	fetchTPhooks();
    doModules();
    
	// set up the layers, but not for certain actions
	if(!isset($_REQUEST['preview']) && !isset($_REQUEST['quote']) && !isset($_REQUEST['xml']) && !isset($aoptions['nolayer']))
		$context['template_layers'][] = $context['TPortal']['hooks']['tp_layer'];

	loadtemplate('TPsubs');
	loadtemplate('TPBlockLayout');
	if(loadlanguage('TPortal') == false)
		loadlanguage('TPortal', 'english');

	$context['TPortal']['membergroups']=$user_info['groups'];

	// is the permanent theme option set?
	if(isset($_GET['permanent']) && !empty($_GET['theme']) && $context['user']['is_logged'])
		TP_permaTheme($_GET['theme']);
	
	// do after action
	if(isset($_GET['page']))
		$context['shortID'] = doTPpage();
	elseif(isset($_GET['cat']))
		$context['catshortID'] = doTPcat();
	elseif(isset($_GET['action']))
		checkTPaction();
	else
	{
		if(!isset($_GET['action']) && !isset($_GET['board']) && !isset($_GET['topic']))
			doTPfrontpage();
	}
	// check that we are going directly to forum
	if(count($context['linktree'])>1 && $settings['TPortal_front_type']=='boardindex')
	{
		$temp=array_shift($context['linktree']);
		$t=array_shift($context['linktree']);
		array_unshift($context['linktree'],$temp);
	}

	// determine the blocks
	doTPblocks();

	// for some very large forum sections, give the option to hide bars
	if($context['TPortal']['hidebars_profile']=='1' && $context['TPortal']['action']=='profile')
		tp_hidebars('all');
	elseif($context['TPortal']['hidebars_pm']=='1' && $context['TPortal']['action']=='pm')
		tp_hidebars('all');
	elseif($context['TPortal']['hidebars_calendar']=='1' && $context['TPortal']['action']=='calendar')
		tp_hidebars('all');
	elseif($context['TPortal']['hidebars_search']=='1' && in_array($context['TPortal']['action'],array('search','search2')))
		tp_hidebars('all');
	elseif($context['TPortal']['hidebars_memberlist']=='1' && $context['TPortal']['action']=='mlist')
		tp_hidebars('all');

	// if custom actions is specified, hide panels there as well
	if(!empty($context['TPortal']['hidebars_custom']))
	{
		$cactions = explode(",",$context['TPortal']['hidebars_custom']);
		if(in_array($context['TPortal']['action'], $cactions))
			tp_hidebars('all');
	}

	// finally..wap modes should not display the bars
	if(isset($_GET['wap']) || isset($_GET['wap2']) || isset($_GET['imode']))
		tp_hidebars('all');
	

	// load both stylesheets to be sure all is in, but not if thinsg aren't setup!
	if(!empty($settings['default_theme_url']) && !empty($settings['theme_url']) && file_exists($settings['theme_dir'].'/tp-style.css'))
		$context['html_headers'] .= '
	<link rel="stylesheet" type="text/css" href="' . $settings['theme_url'] . '/tp-style.css?fin11" />';
	else
		$context['html_headers'] .= '
	<link rel="stylesheet" type="text/css" href="' . $settings['default_theme_url'] . '/tp-style.css?fin11" />';

	if(!empty($context['TPortal']['padding']))
		$context['html_headers'] .= '
	<style type="text/css">
		.block_leftcontainer, 
		.block_rightcontainer, 
		.block_centercontainer, 
		.block_uppercontainer, 
		.block_lowercontainer, 
		.block_topcontainer, 
		.block_bottomcontainer 
		{
			padding-bottom: ' . $context['TPortal']['padding'] . 'px;
		}
		#tpleftbarHeader
		{
			margin-right: ' . $context['TPortal']['padding'] . 'px;
		}
		#tprightbarHeader
		{
			margin-left: ' . $context['TPortal']['padding'] . 'px;
		}
	</style>';

	// if we are in permissions admin section, load all permissions
	if((isset($_GET['action']) && $_GET['action']=='permissions') || (isset($_GET['sa']) && $_GET['sa']=='permissions'))
		TPcollectPermissions();

	// maybe we are at the password pages?
	if(isset($_REQUEST['action']) && in_array($_REQUEST['action'],array('login2','profile2')))
		tp_hidebars('all');

/*
	// are we allowed to tag boards? include any
	if(!empty($_GET['topic']) && empty($_GET['action']))
	{
		if($context['TPortal']['tagtopics']==1 && allowedTo(array('tp_articles','tp_settings')))
			$context['template_layers'][] = 'TPtagtopics';
		elseif($context['TPortal']['tagtopics']==1 && !allowedTo(array('tp_articles','tp_settings')) && allowedTo('tp_tag'))
			$context['template_layers'][] = 'TPtagtopicsOnly';
		$context['template_layers'][] = 'TPtagtopicsGeneral';
	}
	elseif(!empty($_GET['board']) && empty($_GET['action']))
	{
		if($context['TPortal']['tagboards']==1 && allowedTo(array('tp_articles','tp_settings')))
			$context['template_layers'][] = 'TPtagboards';
		elseif($context['TPortal']['tagboards']==1 && !allowedTo(array('tp_articles','tp_settings')) && allowedTo('tp_tag'))
			$context['template_layers'][] = 'TPtagboardsOnly';
		$context['template_layers'][] = 'TPtagboardsGeneral';
	}
*/
	// are we on search page? then add TP search options as well!
	if($context['TPortal']['action']=='search')
		$context['template_layers'][] = 'TPsearch';

	// choosing topics for frontpage
	if(!empty($_GET['topic']) && empty($_GET['action']))
	{
		if(allowedTo(array('tp_settings')))
			$context['template_layers'][] = 'tpfrontpagetopics';
	}

	// any modules needed to load then?
	if(sizeof($context['TPortal']['always_loaded'])>0)
	{
		foreach($context['TPortal']['always_loaded'] as $loaded => $fil)
			require_once($boarddir. '/tp-files/tp-modules/'. $fil);
	}
	tp_setupUpshrinks();

	// finally..any errors?
	if(isset($article_error))
		fatal_error($txt['tp-articlenotexist']);

	// let a module take ovr
	if($context['TPortal']['front_type']=='module' && !isset($_GET['page']) && !isset($_GET['cat']) && !isset($_GET['action']))
	{
		// let the modoule take over
		require_once($context['TPortal']['tpmodules']['frontsection'][$context['TPortal']['front_module']]['sourcefile']);
		if(function_exists($context['TPortal']['tpmodules']['frontsection'][$context['TPortal']['front_module']]['function']))
			call_user_func($context['TPortal']['tpmodules']['frontsection'][$context['TPortal']['front_module']]['function']);
		else
			echo 'No output from module.';
	}

}


function TP_loadTheme()
{
	global $db_prefix, $context, $scripturl,$txt , $user_info, $settings , $modSettings, $ID_MEMBER, $boardurl, $sourcedir;

	require_once($sourcedir.'/TPSubs.php');

	// prefix of the TP tables
	$tp_prefix = $db_prefix.'tp_';

	$settings['tp_prefix'] = $tp_prefix;
	$theme=0;

	// are we on a article? check it for custom theme
    if(isset($_GET['page']) && !isset($_GET['action']))
	{
		// fetch the custom theme if any
		$pag=tp_sanitize($_GET['page']);
		if(is_numeric($pag))
			$request =  tp_query("SELECT ID_THEME FROM " . $tp_prefix . "articles WHERE id=" .$pag, __FILE__, __LINE__);
		else
			$request =  tp_query("SELECT ID_THEME FROM " . $tp_prefix . "articles WHERE shortname='" .$pag. "'", __FILE__, __LINE__);

		if(tpdb_num_rows($request)>0)
		{
			$row=tpdb_fetch_row($request);
			$theme=$row[0];
			tpdb_free_result($request);
		}
    }
    // are we on frontpage? and it shows fetured article?
    elseif(!isset($_GET['page']) && !isset($_GET['action']) && !isset($_GET['board']) && !isset($_GET['topic']))
	{
		// fetch the custom theme if any
		$request =  tp_query("SELECT COUNT(*) FROM " . $tp_prefix . "settings WHERE name='front_type' AND value='single_page' ", __FILE__, __LINE__);
		if(tpdb_num_rows($request)>0)
		{
			$row=tpdb_fetch_row($request);
			tpdb_free_result($request);
			$request =  tp_query("SELECT art.ID_THEME, sett.value FROM (" . $tp_prefix . "articles AS art, " . $tp_prefix . "settings AS sett) WHERE sett.name='featured_article' AND sett.value=art.id ", __FILE__, __LINE__);
			if(tpdb_num_rows($request)>0)
			{
				$row=tpdb_fetch_row($request);
				$theme=$row[0];
				tpdb_free_result($request);
			}
		}
    }
    // how about dlmanager, any custom theme there?
    elseif(isset($_GET['action']) && $_GET['action']=='tpmod' && isset($_GET['dl']))
	{
		// fetch the custom theme if any
		$request =  tp_query("SELECT value FROM " . $tp_prefix . "settings WHERE name='dlmanager_theme'", __FILE__, __LINE__);
		if(tpdb_num_rows($request)>0)
		{
			$row=tpdb_fetch_row($request);
			$theme=$row[0];
			tpdb_free_result($request);
		}
    }
 	return $theme;
}

function setupTPsettings()
{
	global $maintenance, $db_prefix, $context, $scripturl,$txt , $user_info, $settings , $modSettings, $ID_MEMBER, $boarddir, $boardurl, $sourcedir, $forum_version;
	
	$tp_prefix = $settings['tp_prefix'];
	$context['TPortal']['always_loaded'] = array();

	// get the settings
	$request =  tp_query("SELECT name,value FROM " . $tp_prefix . "settings", __FILE__, __LINE__);
	if (tpdb_num_rows($request) > 0)
	{
		while($row = tpdb_fetch_assoc($request))
		{
			$context['TPortal'][$row['name']]=$row['value'];
			// ok, any module that like to load?
			if(substr($row['name'],0,11)=='load_module')
				$context['TPortal']['always_loaded'][] = $row['value'];
		}
		tpdb_free_result($request);
	}
	
	// setup the userbox settings
	$userbox = explode(",",$context['TPortal']['userbox_options']);
	foreach($userbox as $u => $val)
		$context['TPortal']['userbox'][$val]=1;

	// setup sizes for DL and articles
	$context['TPortal']['dl_screenshotsize']=explode(",", $context['TPortal']['dl_screenshotsizes']);
	$context['TPortal']['art_imagesize']=explode(",", $context['TPortal']['art_imagesizes']);

	// another special case: sitemap items
	$context['TPortal']['sitemap'] = array();
	foreach($context['TPortal'] as $what => $value)
	{
		if(substr($what,0,14) == 'sitemap_items_' && !empty($value))
			$context['TPortal']['sitemap_items'] .= ','. $value;
	}	
	if(isset($context['TPortal']['sitemap_items']))
	{
		$context['TPortal']['sitemap']=explode(',',$context['TPortal']['sitemap_items']);
	}
	// yet another special case: category list
	$context['TPortal']['category_list'] = array();
	if(isset($context['TPortal']['cat_list']))
		$context['TPortal']['category_list']=explode(',',$context['TPortal']['cat_list']);

	// setup path for TP images, fallback on default theme - but not if its set already!
	if(!isset($settings['tp_images_url']))
	{
		// check if the them has a folder
		if(file_exists($settings['theme_dir'].'/images/tinyportal/TParticle.gif'))
			$settings['tp_images_url'] = $settings['images_url'] . '/tinyportal';
		else
			$settings['tp_images_url'] = $settings['default_images_url'] . '/tinyportal';
	}

	// hooks setting up
	$context['TPortal']['hooks'] = array(
		'topic_check' => array(),
		'board_check' => array(),
		'tp_layer' => 'tp',
		'tp_block' => 'TPblock',
	);
	
	// any tags specified?
	if(!empty($_REQUEST['gtag']))
	{
		if(substr($_REQUEST['gtag'],0,1)==',')
			$_REQUEST['gtag']=substr($_REQUEST['gtag'],1);
		if(substr($_REQUEST['gtag'],(strlen($_REQUEST['gtag'])-1),1)==',')
			$_REQUEST['gtag']=substr($_REQUEST['gtag'],0,strlen($_REQUEST['gtag'])-1);

		$context['TPortal']['myglobaltags'] = explode(",",$_REQUEST['tptag']);

		$context['TPortal']['global_tags']=array();
		$request =  tp_query("SELECT * FROM " . $tp_prefix . "variables WHERE type='globaltag'", __FILE__, __LINE__);
		if(tpdb_num_rows($request)>0)
		{
			while($row=tpdb_fetch_assoc($request))
			{
				$context['TPortal']['global_tags'][$row['value1']] = array(
					'id' => $row['id'],
					'tag' => $row['value1'],
					'related' => $row['value2'],
				);
			}
			tpdb_free_result($request);
		}
	}
	// Set the page title.
	$context['page_title'] = $context['forum_name'];
	if(!empty($context['TPortal']['frontpage_title']))
		$context['page_title'] = $context['TPortal']['frontpage_title'];

	if(isset($_GET['action']) && $_GET['action']=='tpadmin')
		$context['page_title'] = $context['forum_name'] . ' - TP Admin';

	// start of things
	$context['TPortal']['mystart']=0;
	if(isset($_GET['p']) && $_GET['p']!='' && is_numeric($_GET['p']))
		$context['TPortal']['mystart']=$_GET['p'];

	$context['tp_html_headers']= '';

   // any sorting taking place?
   if(isset($_GET['tpsort']))
        $context['TPortal']['tpsort']=$_GET['tpsort'];
   else
        $context['TPortal']['tpsort']='';

	// if not in forum start off empty
	$context['TPortal']['is_front']=false;
	$context['TPortal']['is_frontpage']=false;
	if(!isset($_GET['action']) && !isset($_GET['board']) && !isset($_GET['topic']))
	{
		TPstrip_linktree();
		// a switch to make it clear what is "forum" and not
		$context['TPortal']['not_forum']=true;
	}
	// are we actually on frontpage then?
	if(!isset($_GET['cat']) && !isset($_GET['page']) && !isset($_GET['action']))
	{
		$context['TPortal']['is_front']=true;
		$context['TPortal']['is_frontpage']=true;
	}

	$context['tp_prefix']=$tp_prefix;

	// emergency - don't render any blocks :)
	$noblocks = isset($_GET['noblocks']) ? true : false;

	// if we are in maintance mode, just hide panels 
	if (!empty($maintenance) && !allowedTo('admin_forum'))
		tp_hidebars('all');

	// save the action value
	$context['TPortal']['action'] = !empty($_GET['action']) ? tp_sanitize($_GET['action']) : '';
	
	// save the frontapge setting for SMF
	$settings['TPortal_front_type'] = $context['TPortal']['front_type'];
}

function fetchTPhooks()
{
	global $maintenance, $tp_prefix, $db_prefix, $context, $scripturl,$txt , $user_info, $settings , $modSettings, $ID_MEMBER, $boarddir, $boardurl, $sourcedir, $forum_version;

	$tp_prefix = $settings['tp_prefix'];

	// any hooks for where we are at?
	$what_board = isset($context['current_board']) ? $context['current_board'] : 0;
	$what_topic = isset($context['current_topic']) ? $context['current_topic'] : 0;
	if($what_topic>0)
		$what_board=0;
	
	$what_page = (isset($_GET['page']) && $context['current_action']!='help') ? $_GET['page'] : 0;
	$what_cat = isset($_GET['cat']) ? $_GET['cat'] : 0;

	// are we inside a board?
	if($what_board>0)
	{
		$request2 =  tp_query("SELECT * FROM " . $tp_prefix . "variables WHERE type='layerhook' AND	value1='what_board'", __FILE__, __LINE__);
		$param=$what_board;
	}
	// perhaps a topic then?
	elseif($what_topic>0)
	{
		$request2 =  tp_query("SELECT * FROM " . $tp_prefix . "variables WHERE type='layerhook' AND	value1='what_topic'", __FILE__, __LINE__);
		$param=$what_topic;
	}
	// alright, an article?
	elseif($what_page>0)
	{
		$request2 =  tp_query("SELECT * FROM " . $tp_prefix . "variables WHERE type='layerhook' AND	value1='what_page'", __FILE__, __LINE__);
		$param=$what_page;
	}
	// a category of articles?
	elseif($what_cat>0)
	{
		$request2 =  tp_query("SELECT * FROM " . $tp_prefix . "variables WHERE type='layerhook' AND	value1='what_cat'", __FILE__, __LINE__);
		$param=$what_cat;
	}
	// guess neither..
	else
		$param=0;

	// do the actual hooks
	if(!empty($request2) && tpdb_num_rows($request2)>0)
	{
		while($row = tpdb_fetch_assoc($request2))
		{
			if(file_exists($sourcedir . '/' .$row['value2']))
			{
				require_once($sourcedir. '/' .$row['value2']);
				if(function_exists($row['value3']))
					call_user_func($row['value3'],	 $param);
			}
		}
		tpdb_free_result($request2);
	}

	// something should always load? + submissions
	$types = array('layerhook' , 'art_not_approved', 'dl_not_approved');

	$request2 =  tp_query("SELECT * FROM " . $tp_prefix . "variables WHERE type IN ('" . implode("','" ,$types) . "')", __FILE__, __LINE__);
	
	$context['TPortal']['submitcheck'] = array('articles' => 0, 'uploads' => 0);

	// do the actual hooks
	if(!empty($request2) && tpdb_num_rows($request2)>0)
	{
		while($row = tpdb_fetch_assoc($request2))
		{
			if(allowedTo('tp_articles') && $row['type'] == 'art_not_approved')
				$context['TPortal']['submitcheck']['articles']++;
			// check submission on dl manager, but only if its active
			if(allowedTo('tp_dlmanager') && $context['TPortal']['show_download'] && $row['type'] == 'dl_not_approved')
				$context['TPortal']['submitcheck']['uploads']++;

			// something alwasy loads?
			if($row['value1'] == 'what_all' && $row['type'] == 'layerhook' && file_exists($sourcedir . '/' .$row['value2']))
			{
				require_once($sourcedir. '/' .$row['value2']);
				if(function_exists($row['value3']))
					call_user_func($row['value3'],	 $param);
			}
			// something always loads?
			if($row['value1'] == 'what_all_tpmodule' && $row['type'] == 'layerhook' && file_exists($boarddir . '/tp-files/tp-modules/' .$row['value2'].'/Sources/'.$row['value2']. '.php'))
			{
				// is it installed at all?
				if(isset($context['TPortal'][$row['value4']]) && $context['TPortal'][$row['value4']] == 1)
				{
					require_once($boarddir . '/tp-files/tp-modules/' .$row['value2'].'/Sources/'.$row['value2']. '.php');
					if(function_exists($row['value3']))
						call_user_func($row['value3'],	 $param);
				}
			}
		}
		tpdb_free_result($request2);
	}
}

function doTPpage()
{
	global $db_prefix, $tp_prefix, $context, $scripturl, $txt, $user_info, $settings;
	global $func, $modSettings, $ID_MEMBER, $boarddir, $boardurl, $sourcedir;

	$tp_prefix = $settings['tp_prefix'];

	// Set the avatar height/width
	if ($modSettings['avatar_action_too_large'] == 'option_html_resize' || $modSettings['avatar_action_too_large'] == 'option_js_resize')
	{
		$avatar_width = !empty($modSettings['avatar_max_width_external']) ? ' width="' . $modSettings['avatar_max_width_external'] . '"' : '';
		$avatar_height = !empty($modSettings['avatar_max_height_external']) ? ' height="' . $modSettings['avatar_max_height_external'] . '"' : '';
	}
	else
	{
		$avatar_width = '';
		$avatar_height = '';
	}
	
	// check validity and fetch it
	if(!empty($_GET['page']))
	{
		$page = tp_sanitize($_GET['page']);
		if(!empty($page))
		{
			$request =  tp_query("SELECT art.*, art.authorID, art.ID_THEME, var.value1,var.value2,var.value3,var.value4, var.value5,var.value7,var.value8, art.type as rendertype, 
				IFNULL(mem.realName,art.author) as realName, mem.avatar, mem.posts, mem.dateRegistered,mem.lastLogin,
				IFNULL(a.ID_ATTACH, 0) AS ID_ATTACH, a.filename, a.attachmentType, var.value9 
				FROM " . $tp_prefix . "articles as art 
				LEFT JOIN " . $db_prefix . "members AS mem ON (mem.ID_MEMBER = art.authorID)
				LEFT JOIN " . $db_prefix . "attachments AS a ON (a.ID_MEMBER = art.authorID)
				LEFT JOIN " . $tp_prefix . "variables as var ON (var.id= art.category) 
				WHERE " . (is_numeric($page) ? "art.id=".$page : "art.shortname='".$page."'") . " 
				LIMIT 1", __FILE__, __LINE__);
			if(tpdb_num_rows($request)>0)
			{
				$article = tpdb_fetch_assoc($request);
				$valid=true;
				tpdb_free_result($request);
				// if its not approved, say so.
				if($article['approved']==0)
				{
					TP_error($txt['tp-notapproved']);
					$shown = true;
					if(!allowedTo('tp_articles'))
						$valid=false;
				}
				// likewise for off.
				if($article['off']==1)
				{
					if(!isset($shown))
						TP_error($txt['tp-noton']);
					$shown = true;
					if(!allowedTo('tp_articles'))
						$valid=false;
				}
				// and for no category
				if($article['category']<1 || $article['category']>9999)
				{
					if(!isset($shown))
						TP_error($txt['tp-nocategory']);
					$shown = true;
					if(!allowedTo('tp_articles'))
						$valid=false;
				}
				if( get_perm($article['value3']) && $valid)
				{	
					// compability towards old articles
					if(empty($article['type']))
					{
						$article['type'] = $article['rendertype'] = 'html'; 
					}
					$article['body'] = html_entity_decode($article['body'], ENT_QUOTES);
					$article['intro'] = html_entity_decode($article['intro'], ENT_QUOTES);
					$article['subject'] = html_entity_decode($article['subject'], ENT_QUOTES);
					$article['value1'] = html_entity_decode($article['value1'], ENT_QUOTES);
                    // Add ratings together
                    $article['rating'] = array_sum(explode(',', $article['rating']));
					// allowed and all is well, go on with it.
					$context['TPortal']['article'] = $article;

					$context['TPortal']['article']['avatar'] = $article['avatar'] == '' ? ($article['ID_ATTACH'] > 0 ? '<img src="' . (empty($article['attachmentType']) ? $scripturl . '?action=dlattach;attach=' . $article['ID_ATTACH'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $article['filename']) . '" alt="" class="avatar" border="0" />' : '') : (stristr($article['avatar'], 'http://') ? '<img src="' . $article['avatar'] . '"' . $avatar_width . $avatar_height . ' alt="" class="avatar" border="0" />' : '<img src="' . $modSettings['avatar_url'] . '/' . $func['htmlspecialchars']($article['avatar']) . '" alt="" class="avatar" border="0" />');
				
					// update views
					$request =  tp_query("UPDATE " . $tp_prefix . "articles SET views=views+1 WHERE " . (is_numeric($page) ? "id=".$page : "shortname='".$page."'") . "  LIMIT 1", __FILE__, __LINE__);
					
					// fetch and update last access by member(to log which comment is new)
					$now = time();
					$request = tp_query("SELECT item FROM " . $tp_prefix . "data WHERE ID_MEMBER=" . $ID_MEMBER . " AND type=1 AND value=" . $article['id'] . " LIMIT 1", __FILE__, __LINE__);
					if(tpdb_num_rows($request)>0)
					{
						$row=tpdb_fetch_row($request);
						$last=$row[0];
						tpdb_free_result($request);
						$request =  tp_query("UPDATE " . $tp_prefix . "data SET item=" . $now . " WHERE ID_MEMBER=" . $ID_MEMBER . " AND type=1 AND value=" . $article['id'], __FILE__, __LINE__);
					}
					else
					{
						$last = $now;
						$request = tp_query("INSERT INTO " . $tp_prefix . "data (type, ID_MEMBER, value, item) VALUES (1," . $ID_MEMBER . ", " . $article['id'] . ", '" . $now. "')", __FILE__, __LINE__);
					}

					require_once($sourcedir . '/TPcommon.php');

					// ok, how manya rticles have this member posted?
					$request =  tp_query("SELECT id FROM " . $tp_prefix . "articles 
					WHERE authorID = " . $context['TPortal']['article']['authorID'] . "
					AND off= 0", __FILE__, __LINE__);
					if(tpdb_num_rows($request)>0)
					{
						$context['TPortal']['article']['countarticles'] = tpdb_num_rows($request);
						tpdb_free_result($request);
					}
					else
						$context['TPortal']['article']['countarticles'] = 0;
					
					// fetch any comments
					$request =  tp_query("SELECT var.* , IFNULL(mem.realName,0) as realName,mem.avatar,
					IFNULL(a.ID_ATTACH, 0) AS ID_ATTACH, a.filename, a.attachmentType
					FROM " . $tp_prefix . "variables AS var 
					LEFT JOIN " . $db_prefix . "members as mem ON (var.value3 = mem.ID_MEMBER)
					LEFT JOIN " . $db_prefix . "attachments AS a ON (a.ID_MEMBER = mem.ID_MEMBER)
					WHERE var.type='article_comment'
					AND var.value5= " . $article['id'] . "
					ORDER BY var.value4 ASC", __FILE__, __LINE__);

					$ccount=0; $newcount=0;
					if(tpdb_num_rows($request)>0)
					{
						$context['TPortal']['article']['comment_posts'] = array();
						while($row=tpdb_fetch_assoc($request))
						{
							$context['TPortal']['article']['comment_posts'][] = array(
								'id' => $row['id'],
								'subject' => html_entity_decode($row['value1'], ENT_QUOTES),
								'text' => parse_bbc($row['value2']),
								'timestamp' => $row['value4'],
								'date' => timeformat($row['value4']),
								'posterID' => $row['value3'],
								'poster' => $row['realName'],
								'is_new' => ($row['value4']>$last) ? true : false ,
								'avatar' => array(
									'name' => &$row['avatar'],
									'image' => $row['avatar'] == '' ? ($row['ID_ATTACH'] > 0 ? '<img src="' . (empty($row['attachmentType']) ? $scripturl . '?action=tpmod;sa=tpattach;attach=' . $row['ID_ATTACH'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) . '" alt="" class="avatar" border="0" />' : '') : (stristr($row['avatar'], 'http://') ? '<img src="' . $row['avatar'] . '"' . $avatar_width . $avatar_height . ' alt="" class="avatar" border="0" />' : '<img src="' . $modSettings['avatar_url'] . '/' . $func['htmlspecialchars']($row['avatar']) . '" alt="" class="avatar" border="0" />'),
									'href' => $row['avatar'] == '' ? ($row['ID_ATTACH'] > 0 ? (empty($row['attachmentType']) ? $scripturl . '?action=tpmod;sa=tpattach;attach=' . $row['ID_ATTACH'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) : '') : (stristr($row['avatar'], 'http://') ? $row['avatar'] : $modSettings['avatar_url'] . '/' . $row['avatar']),
									'url' => $row['avatar'] == '' ? '' : (stristr($row['avatar'], 'http://') ? $row['avatar'] : $modSettings['avatar_url'] . '/' . $row['avatar'])
								),
							);
							$ccount++;
							if($row['value4']>$last)
								$newcount++;
						}
						$context['TPortal']['article_comments_new']=$newcount;
						$context['TPortal']['article_comments_count']=$ccount;
					}
					// if the count differs, update it
					if($ccount!=$article['comments'])
						tp_query("UPDATE " . $tp_prefix . "articles SET comments= " . $ccount . " WHERE id=" . $article['id'], __FILE__, __LINE__);

					// the frontblocks should not display here
					$context['TPortal']['frontpanel']=0;
					// sort out the options
					$context['TPortal']['article']['visual_options'] = explode(',', $article['options']);

					// the custom widths
					foreach ($context['TPortal']['article']['visual_options'] as $pt)
					{
						if(substr($pt,0,11)=='lblockwidth')
							$context['TPortal']['blockwidth_left']=substr($pt,11);
						if(substr($pt,0,11)=='rblockwidth')
							$context['TPortal']['blockwidth_right']=substr($pt,11);
					}
					// check if no theme is to be applied
					if(in_array('nolayer', $context['TPortal']['article']['visual_options']))
					{
						$context['template_layers']=array('nolayer');
						// add the headers!
						$context['tp_html_headers'] .= $article['headers'];
					}
					// set bars on/off according to options, setting override
					$all=array('showtop','centerpanel','leftpanel','rightpanel','toppanel','bottompanel','lowerpanel');
					$all2=array('top','cblock','lblock','rblock','tblock','bblock','lbblock','comments','views','rating','date','title',
					'commentallow','commentupshrink','ratingallow','nolayer','avatar');

					for($p=0 ; $p<6 ; $p++)
					{
						$primary=$context['TPortal'][$all[$p]];
						if(in_array($all2[$p], $context['TPortal']['article']['visual_options']))
							$secondary=1;
						else
							$secondary=0;

						if($primary=='1')
							$context['TPortal'][$all[$p]] = $secondary;
					}
					$ct = explode("|",$article['value7']);
					$cat_opts = array();
					foreach($ct as $cc => $val)
					{
						$ts = explode("=",$val);
						if(isset($ts[0]) && isset($ts[1]))
							$cat_opts[$ts[0]] = $ts[1];
					}
					// decide the template
					if(isset($cat_opts['catlayout']) && $cat_opts['catlayout'] == 7)
						$cat_opts['template'] = $article['value9'];
					
					$context['TPortal']['article']['category_opts'] = $cat_opts;
					
					// the article should follow panel settngs from category?
					if(in_array('inherit', $context['TPortal']['article']['visual_options']))
					{
						// set bars on/off according to options, setting override
						$all=array('upperpanel','leftpanel','rightpanel','toppanel','bottompanel','lowerpanel');
						for($p=0 ; $p<5 ; $p++)
						{
							if(isset($cat_opts[$all[$p]]))
								$context['TPortal'][$all[$p]] = $cat_opts[$all[$p]];
						}
					}
							
					// should we supply links to articles in same category?
					if(in_array('category', $context['TPortal']['article']['visual_options']))
					{
						$request =  tp_query("SELECT id, subject, shortname
							FROM " . $tp_prefix . "articles 
							WHERE category=" . $context['TPortal']['article']['category'] . "
							AND off=0 
							AND approved=1", __FILE__, __LINE__);
						if(tpdb_num_rows($request)>0)
						{
							$context['TPortal']['article']['others'] = array();
							while($row = tpdb_fetch_assoc($request))
							{
								$row['subject'] = html_entity_decode($row['subject'], ENT_QUOTES);
								if($row['id'] == $context['TPortal']['article']['id'])
									$row['selected'] = 1;

								$context['TPortal']['article']['others'][] = $row;
							}
							tpdb_free_result($request);
						}
					}

					// can we rate this article?
					$context['TPortal']['article']['can_rate'] = in_array($context['user']['id'], explode(",",$article['voters'])) ? false : true;

					// Generate a visual verification code for comments in the article.
					if (!empty($context['TPortal']['articles_comment_captcha']))
					{
						$context['use_graphic_library'] = in_array('gd', get_loaded_extensions());
						$context['verification_image_href'] = $scripturl . '?action=verificationcode;rand=' . md5(rand());

						// Only generate a new code if one hasn't been set yet
						// Skip I, J, L, O and Q.
						$character_range = array_merge(range('A', 'H'), array('K', 'M', 'N', 'P'), range('R', 'Z'));

						// Generate a new code.
						$_SESSION['visual_verification_code'] = '';
						for ($i = 0; $i < 5; $i++)
							$_SESSION['visual_verification_code'] .= $character_range[array_rand($character_range)];
					}

					// are we rather printing this article and printing page is allowed?
					if(isset($_GET['print']) && $context['TPortal']['print_articles']==1)
					{
						if(!isset($article['id']))
							redirectexit();
						

						$what = '<h2>' . html_entity_decode($article['subject'], ENT_QUOTES) . ' </h2>'.html_entity_decode($article['body'], ENT_QUOTES);
						$pwhat = 'echo \'<h2>\' . html_entity_decode($article[\'subject\'], ENT_QUOTES) . \'</h2>\';' . html_entity_decode($article['body'], ENT_QUOTES);
						if($row['type']=='php')
							$context['TPortal']['printbody'] = eval($pwhat);
						elseif($row['type']=='bbc')
							$context['TPortal']['printbody'] = parse_bbc($what);
						else
							$context['TPortal']['printbody'] = $what;
						
						$context['TPortal']['print'] = '<a href="' .$scripturl . '?page='. $article['id'] . '"><strong>' . $txt['tp-printgoback'] . '</strong></a>';

						loadtemplate('TPprint');
						$context['template_layers'] = array('tp_print');
						$context['sub_template'] = 'tp_print_body';	
						tp_hidebars();
					}
					// linktree?
					if(!in_array('linktree', $context['TPortal']['article']['visual_options']))
						$context['linktree'] = '';
					else
					{
						// we need the categories for the linktree
						$allcats = array();
						$request =  tp_query("SELECT * FROM " . $tp_prefix . "variables WHERE type = 'category'", __FILE__, __LINE__);
						if(tpdb_num_rows($request)>0)
						{
							while($row = tpdb_fetch_assoc($request))
								$allcats[$row['id']] = $row;

							tpdb_free_result($request);
						}
						
						// setup the linkree
						TPstrip_linktree();

						// do the category have any parents?
						$parents=array();
						$parent = $context['TPortal']['article']['category'];
						if(count($allcats)>0)
						{
							while($parent!=0 && isset($allcats[$parent]['id']))
							{
								$parents[]=array(
									'id' => $allcats[$parent]['id'],
									'name' => html_entity_decode($allcats[$parent]['value1'], ENT_QUOTES),
									'shortname' => !empty($allcats[$parent]['value8']) ? $allcats[$parent]['value8'] : $allcats[$parent]['id'],
								);
								$parent=$allcats[$parent]['value2'];
							}
						}
						// make the linktree
						$parts = array_reverse($parents,TRUE);
						// add to the linktree
						foreach($parts as $parent)
							TPadd_linktree($scripturl.'?cat='. $parent['shortname'] , $parent['name']);

						TPadd_linktree($scripturl.'?page='. (!empty($context['TPortal']['article']['shortname']) ? $context['TPortal']['article']['shortname'] : $context['TPortal']['article']['id']) , $context['TPortal']['article']['subject']);
					}

					$context['page_title'] = $context['forum_name'] . ' - '. $context['TPortal']['article']['subject'];
				
					if (WIRELESS)
					{
						$context['TPortal']['single_article'] = true;
						loadtemplate('TPwireless');
						// decide what subtemplate
						$context['sub_template'] = WIRELESS_PROTOCOL . '_tp_page';
					}
				
				}
				return $article['id'];
			}
		}
		else
			tp_fatal_error($txt['tp-notexist']);
	}
	else
		return;
}

function doTPcat()
{
	//return if not quite a category
	if(isset($_GET['action']) && $_GET['action']=='manageboards')
		return;
	
	global $db_prefix, $tp_prefix, $context, $scripturl, $txt, $user_info;
	global $func, $settings, $modSettings, $ID_MEMBER, $boarddir, $boardurl, $sourcedir;

	$tp_prefix = $settings['tp_prefix'];

	// check validity and fetch it
	if(!empty($_GET['cat']))
	{
		$cat = tp_sanitize($_GET['cat']);
		if(!empty($cat))
		{
			// get the category first
			$request =  tp_query("SELECT * FROM " . $tp_prefix . "variables WHERE " . (is_numeric($cat) ? "id=" . $cat : "value8 = '".$cat."'") . "	LIMIT 1", __FILE__, __LINE__);
			if(tpdb_num_rows($request)>0)
			{
				$category=tpdb_fetch_assoc($request);
				tpdb_free_result($request);
				// check permission
				if(get_perm($category['value3']))
				{
					// get the sorting from the category
					$op = explode("|",$category['value7']);
					$options=array();
					foreach($op as $po => $val)
					{
						$a = explode("=",$val);
						if(isset($a[1]))
							$options[$a[0]] = $a[1];
					}
					$catsort = isset($options['sort']) ? $options['sort'] : 'date';
					
					$catsort_order = isset($options['sortorder']) ? $options['sortorder'] : 'desc';
					$max = empty($options['articlecount']) ? $context['TPortal']['frontpage_limit'] : $options['articlecount'];
					$start=$context['TPortal']['mystart'];

					// some swapping to avoid compability issues
					$options['catlayout'] = isset($options['catlayout']) ? $options['catlayout'] : 1;
					
					// make the template
					if($options['catlayout']==7)
						$context['TPortal']['frontpage_template'] = $category['value9'];

					// allowed and all is well, go on with it.
					$context['TPortal']['category']=$category;
					$context['TPortal']['category']['articles'] = array();

					// copy over the options as well
					$context['TPortal']['category']['options'] = $options;

					// set bars on/off according to options, setting override
					$all = array('upperpanel','leftpanel','rightpanel','toppanel','bottompanel','lowerpanel');
					for($p=0 ; $p<5 ; $p++)
					{
						if(isset($options[$all[$p]]) && $context['TPortal'][$all[$p]]==1)
							$context['TPortal'][$all[$p]] = 1;
						else
							$context['TPortal'][$all[$p]] = 0;

					}

					// fallback value
					if(!isset($context['TPortal']['category']['options']['catlayout']))
						$context['TPortal']['category']['options']['catlayout'] = 1;

					$request =  tp_query("SELECT art.id, IF(art.useintro>0, art.intro, art.body) AS body,
						art.date, art.category, art.subject, art.authorID, art.frame, art.comments, art.options,
						art.comments_var, art.views, art.rating, art.voters, art.shortname, art.useintro, art.intro,
						art.fileimport, art.topic, art.illustration,IFNULL(art.type,'html') as rendertype ,IFNULL(art.type,'html') as type, art.global_tag,
						IFNULL(mem.realName, art.author) as realName, mem.avatar, mem.posts, mem.dateRegistered,mem.lastLogin,
						IFNULL(a.ID_ATTACH, 0) AS ID_ATTACH, a.filename, a.attachmentType
						FROM " . $tp_prefix . "articles AS art
						LEFT JOIN " . $db_prefix . "members AS mem ON (art.authorID = mem.ID_MEMBER) 
						LEFT JOIN " . $db_prefix . "attachments AS a ON (a.ID_MEMBER = mem.ID_MEMBER)
						WHERE art.category=" . $category['id'] . " 
						AND art.off=0 
						AND art.approved=1 
						ORDER BY art.sticky desc, art." . $catsort ." " . $catsort_order . "
						LIMIT " .$start ."," .$max, __FILE__, __LINE__);
					
					if(tpdb_num_rows($request)>0)
					{
						$total = tpdb_num_rows($request); $col1 = ceil($total/2);
						$col2 = $total - $col1; $counter=0;
						$context['TPortal']['category']['col1'] = array(); $context['TPortal']['category']['col2'] = array();
						while($row = tpdb_fetch_assoc($request))
						{
							// fix old articles
							$row['body'] = html_entity_decode($row['body'], ENT_QUOTES);
							$row['intro'] = html_entity_decode($row['intro'], ENT_QUOTES);
							$row['subject'] = html_entity_decode($row['subject'], ENT_QUOTES);
							// Add the rating together
							$row['rating'] = array_sum(explode(',', $row['rating']));
							// expand the vislaoptions
							$row['visual_options'] = explode(',', $row['options']);
							$row['avatar'] = $row['avatar'] == '' ? ($row['ID_ATTACH'] > 0 ? '<img src="' . (empty($row['attachmentType']) ? $scripturl . '?action=dlattach;attach=' . $row['ID_ATTACH'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) . '" alt="&nbsp;"  />' : '') : (stristr($row['avatar'], 'http://') ? '<img src="' . $row['avatar'] . '" alt="&nbsp;" />' : '<img src="' . $modSettings['avatar_url'] . '/' . $func['htmlspecialchars']($row['avatar']) . '" alt="&nbsp;" />');
							
							if($counter == 0)
								$context['TPortal']['category']['featured'] = $row;
							elseif($counter < $col1 )
								$context['TPortal']['category']['col1'][] = $row;
							elseif($counter > $col1 || $counter == $col1)
								$context['TPortal']['category']['col2'][] = $row;

							$counter++;						
						}
						tpdb_free_result($request);
					}
					
					// any children then?
					$allcats = array();
					$context['TPortal']['category']['children'] = array();
					$request =  tp_query("SELECT cat.*, COUNT(art.id) as articlecount
						FROM (" . $tp_prefix . "variables as cat)
						LEFT JOIN " . $tp_prefix . "articles as art ON (art.category = cat.id)
						WHERE cat.type = 'category' GROUP BY art.category", __FILE__, __LINE__);
					if(tpdb_num_rows($request)>0)
					{
						while($row = tpdb_fetch_assoc($request))
						{
							$row['value1'] = html_entity_decode($row['value1'], ENT_QUOTES);
							// get any children
							if($row['value2'] == $cat)
								$context['TPortal']['category']['children'][] = $row;
							
							$allcats[$row['id']] = $row;
						}
						tpdb_free_result($request);
					}
					
					// get how many articles in all
					$request =  tp_query("SELECT COUNT(*) FROM " . $tp_prefix . "articles WHERE category=" . $category['id'] . " AND off=0 AND approved=1", __FILE__, __LINE__);
					if(tpdb_num_rows($request)>0)
					{
						$row=tpdb_fetch_row($request);
						$all_articles=$row[0];
					}
					else
						$all_articles=0;

					// make the pageindex!
					$context['TPortal']['pageindex'] = TPageIndex($scripturl . '?cat=' . $cat, $start, $all_articles, $max);

					// setup the linkree
					TPstrip_linktree();

					// do the category have any parents?
					$parents=array();
					$parent = $context['TPortal']['category']['value2'];
					// save the immediate for wireless
					
					if(WIRELESS)
					{
						if($context['TPortal']['category']['value2']>0)
							$context['TPortal']['category']['catname'] =  $allcats[$context['TPortal']['category']['value2']]['value1'];
						else
							$context['TPortal']['category']['catname'] =  $txt['tp-frontpage'];
					}
					while($parent!=0)
					{
						$parents[]=array(
							'id' => $allcats[$parent],
							'name' => html_entity_decode($allcats[$parent]['value1'], ENT_QUOTES),
							'shortname' => !empty($allcats[$parent]['value8']) ? $allcats[$parent]['value8'] : $allcats[$parent]['id'],
						);
						$parent=$allcats[$parent]['value2'];
					}

					// make the linktree
					$parts = array_reverse($parents,TRUE);
					// add to the linktree
					foreach($parts as $parent)
						TPadd_linktree($scripturl.'?cat='. $parent['shortname'] , $parent['name']);

					TPadd_linktree($scripturl.'?cat='. $context['TPortal']['category']['id'] , $context['TPortal']['category']['value1']);

					// check clist
					$context['TPortal']['clist'] = array();
					foreach(explode(',' , $context['TPortal']['cat_list']) as $cl => $value)
					{
						if(isset($allcats[$value]) && is_numeric($value))
						{
							$context['TPortal']['clist'][] = array(
									'id' => $value,
									'name' => html_entity_decode($allcats[$value]['value1'], ENT_QUOTES),
									'selected' => $value == $cat ? true : false,
									);
							$txt['catlist'. $value] = html_entity_decode($allcats[$value]['value1'], ENT_QUOTES);
						}
					}
					$context['TPortal']['show_catlist'] = sizeof($context['TPortal']['clist'])>0 ? true : false;
				
					if (WIRELESS)
					{
						$context['TPortal']['single_article'] = false;
						loadtemplate('TPwireless');
						// decide what subtemplate
						$context['sub_template'] = WIRELESS_PROTOCOL . '_tp_cat';
					}
					return $category['id'];
				}
				else
					return;
			}
			else
				return;
		
		}
		else
			return;
	}
	else
		return;
	
}

// check stuff around action
function checkTPaction()
{
	global $db_prefix, $tp_prefix, $context, $scripturl, $txt, $user_info, $settings, $modSettings, $ID_MEMBER, $boarddir, $boardurl, $sourcedir;

	$tp_prefix = $settings['tp_prefix'];

	return;
}

// do the frontpage
function doTPfrontpage()
{
	global $db_prefix, $tp_prefix, $context, $scripturl, $txt, $user_info, $settings;
	global $func, $modSettings, $ID_MEMBER, $boarddir, $boardurl, $sourcedir;

	if(!isset($modSettings['global_character_set']))
		$modSettings['global_character_set'] = '';
	
	$tp_prefix = $settings['tp_prefix'];

	// check we aren't in any other section
	if(isset($_GET['action']) || isset($_GET['board']) || isset($_GET['topic']))
		return;
	
	// set up visual options for frontpage
	$context['TPortal']['visual_opts'] = explode(',', $context['TPortal']['frontpage_visual']);

	// first, the panels
	foreach(array('left','right','center','top','bottom','lower') as $pan => $panel)
	{
		if($context['TPortal'][$panel.'panel'] == 1 && in_array($panel, $context['TPortal']['visual_opts']))
			$context['TPortal'][$panel.'panel'] = 1;
		else
			$context['TPortal'][$panel.'panel'] = 0;
	}
	// get the sorting
	foreach($context['TPortal']['visual_opts'] as $vi => $vo)
	{
		if(substr($vo, 0, 5) == 'sort_')
			$catsort = substr($vo,5);
		else
			$catsort = 'date';
		
		if(substr($vo, 0, 10) == 'sortorder_')
			$catsort_order = substr($vo,10);
		else
			$catsort_order = 'desc';
	}
	if(!in_array($catsort, array('date','authorID','id','parse')))
		$catsort = 'date';

	$max = $context['TPortal']['frontpage_limit'];
	$start = $context['TPortal']['mystart'];

	// fetch the articles, sorted
	if($context['TPortal']['front_type'] == 'articles_only')
	{
		// first, get all available
		if(!$context['user']['is_admin'])
			$artgroups = 'AND (FIND_IN_SET(' . implode(', var.value3) OR FIND_IN_SET(', $user_info['groups']) . ', var.value3))';
		else
			$artgroups = '';
		
		$request =  tp_query("SELECT art.id
			FROM (" . $tp_prefix . "articles AS art, " . $tp_prefix . "variables AS var) 
			WHERE art.off = 0 
			AND var.id = art.category
			" . $artgroups . "
			AND art.category>0
			AND art.approved = 1 
			AND art.frontpage = 1", __FILE__, __LINE__);

		if(tpdb_num_rows($request)>0)
		{
			$articles_total = tpdb_num_rows($request);
			tpdb_free_result($request);
		}	
		else
			$articles_total = 0;;

		// make the pageindex!
		$context['TPortal']['pageindex'] = TPageIndex($scripturl .'?frontpage', $start, $articles_total, $max);

		$request =  tp_query("SELECT art.id, IF(art.useintro>0, art.intro, art.body) AS body,
			art.date, art.category, art.subject, art.authorID, var.value1 as category_name,
			art.frame, art.comments, art.options, art.intro, art.useintro,
			art.comments_var, art.views, art.rating, art.voters, art.shortname,
			art.fileimport, art.topic, art.illustration,art.type as rendertype ,art.global_tag,
			IFNULL(mem.realName, art.author) as realName, mem.avatar, mem.posts, mem.dateRegistered,mem.lastLogin,
			IFNULL(a.ID_ATTACH, 0) AS ID_ATTACH, a.filename, a.attachmentType
			FROM " . $tp_prefix . "articles AS art
			LEFT JOIN " . $tp_prefix . "variables AS var ON(var.id = art.category) 
			LEFT JOIN " . $db_prefix . "members AS mem ON (art.authorID = mem.ID_MEMBER)
			LEFT JOIN " . $db_prefix . "attachments AS a ON (a.ID_MEMBER = mem.ID_MEMBER)
			WHERE art.off = 0 
			" . $artgroups . "
			AND art.category>0
			AND art.approved = 1 
			AND (art.frontpage = 1 OR art.featured =1) 
			ORDER BY art.featured DESC, art.sticky DESC, art." . $catsort ." " . $catsort_order . "
			LIMIT " .$start ."," .$max, __FILE__, __LINE__);
		if(tpdb_num_rows($request)>0)
		{
			$total = tpdb_num_rows($request); $col1 = ceil($total/2);
			$col2 = $total - $col1; $counter=0;

			$context['TPortal']['category'] = array(
				'articles' => array(),
				'col1' => array(),
				'col2' => array(),
				'options' => array(
					'catlayout' => $context['TPortal']['frontpage_catlayout'],
					)
				);

			while($row = tpdb_fetch_assoc($request))
			{
				// expand the vislaoptions
				$row['visual_options'] = explode(",", $row['options']);
				$row['avatar'] = $row['avatar'] == '' ? ($row['ID_ATTACH'] > 0 ? '<img src="' . (empty($row['attachmentType']) ? $scripturl . '?action=dlattach;attach=' . $row['ID_ATTACH'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) . '" alt="&nbsp;"  />' : '') : (stristr($row['avatar'], 'http://') ? '<img src="' . $row['avatar'] . '" alt="&nbsp;" />' : '<img src="' . $modSettings['avatar_url'] . '/' . $func['htmlspecialchars']($row['avatar']) . '" alt="&nbsp;" />');
				
				$row['body'] = html_entity_decode($row['body'], ENT_QUOTES);
				$row['intro'] = html_entity_decode($row['intro'], ENT_QUOTES);
				$row['subject'] = html_entity_decode($row['subject'], ENT_QUOTES);
				$row['category_name'] = html_entity_decode($row['category_name'], ENT_QUOTES);
				if($counter == 0)
					$context['TPortal']['category']['featured'] = $row;
				elseif($counter < $col1 )
					$context['TPortal']['category']['col1'][] = $row;
				elseif($counter > $col1 || $counter == $col1)
					$context['TPortal']['category']['col2'][] = $row;

				$counter++;						
			}
			tpdb_free_result($request);
		}
	}
	// fetch the articles, sorted
	elseif($context['TPortal']['front_type'] == 'single_page')
	{
		$request =  tp_query("SELECT art.id, IF(art.useintro>0, art.intro, art.body) AS body,
			art.date, art.category, art.subject, art.authorID, var.value1 as category_name,
			art.frame, art.comments, art.options, art.intro, art.useintro,
			art.comments_var, art.views, art.rating, art.voters, art.shortname,
			art.fileimport, art.topic, art.illustration,art.type as rendertype ,art.global_tag,
			IFNULL(mem.realName, art.author) as realName, mem.avatar, mem.posts, mem.dateRegistered,mem.lastLogin,
			IFNULL(a.ID_ATTACH, 0) AS ID_ATTACH, a.filename, a.attachmentType
			FROM " . $tp_prefix . "articles AS art
			LEFT JOIN " . $tp_prefix . "variables AS var ON(var.id = art.category) 
			LEFT JOIN " . $db_prefix . "members AS mem ON (art.authorID = mem.ID_MEMBER)
			LEFT JOIN " . $db_prefix . "attachments AS a ON (a.ID_MEMBER = mem.ID_MEMBER)
			WHERE art.off = 0 
			AND art.featured = 1
			AND art.approved = 1 
			LIMIT 1", __FILE__, __LINE__);
		if(tpdb_num_rows($request)>0)
		{
			$context['TPortal']['category'] = array(
				'articles' => array(),
				'col1' => array(),
				'col2' => array(),
				'options' => array(
					'catlayout' => $context['TPortal']['frontpage_catlayout'],
					)
				);

			$row = tpdb_fetch_assoc($request);
			// expand the vislaoptions
				$row['body'] = html_entity_decode($row['body'], ENT_QUOTES);
				$row['intro'] = html_entity_decode($row['intro'], ENT_QUOTES);
				$row['subject'] = html_entity_decode($row['subject'], ENT_QUOTES);
				$row['category_name'] = html_entity_decode($row['category_name'], ENT_QUOTES);
			$row['visual_options'] = explode(",", $row['options']);
			$row['avatar'] = $row['avatar'] == '' ? ($row['ID_ATTACH'] > 0 ? '<img src="' . (empty($row['attachmentType']) ? $scripturl . '?action=dlattach;attach=' . $row['ID_ATTACH'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) . '" alt="&nbsp;"  />' : '') : (stristr($row['avatar'], 'http://') ? '<img src="' . $row['avatar'] . '" alt="&nbsp;" />' : '<img src="' . $modSettings['avatar_url'] . '/' . $func['htmlspecialchars']($row['avatar']) . '" alt="&nbsp;" />');

			$context['TPortal']['category']['featured'] = $row;
			tpdb_free_result($request);
		}
	}
	elseif(in_array($context['TPortal']['front_type'], array('forum_only','forum_selected')))
	{
		$totalmax = 200;
	
		loadLanguage('Stats');
		
		// Find the post ids.
		
		if($context['TPortal']['front_type'] == 'forum_only')
		$request =  tp_query("
			SELECT t.ID_FIRST_MSG
			FROM (" . $db_prefix . "topics as t, " . $db_prefix . "boards as b)
			WHERE t.ID_BOARD=b.ID_BOARD
			AND t.ID_BOARD IN(" . $context['TPortal']['SSI_board'] .")
			" . ($context['TPortal']['allow_guestnews']==0 ? 'AND ' . $user_info['query_see_board'] : '') . "
			ORDER BY t.ID_FIRST_MSG DESC
			LIMIT " . $totalmax, __FILE__, __LINE__);
		else
			$request =  tp_query("
			SELECT t.ID_FIRST_MSG
			FROM (" . $db_prefix . "topics as t, " . $db_prefix . "boards as b)
			WHERE t.ID_BOARD=b.ID_BOARD
			AND t.ID_TOPIC IN(" . (empty($context['TPortal']['frontpage_topics']) ? '0' : $context['TPortal']['frontpage_topics']) .")
			" . ($context['TPortal']['allow_guestnews']==0 ? 'AND ' . $user_info['query_see_board'] : '') . "
			ORDER BY t.ID_FIRST_MSG DESC", __FILE__, __LINE__);

		$posts = array();
		while ($row = tpdb_fetch_assoc($request))
			$posts[] = $row['ID_FIRST_MSG'];
		tpdb_free_result($request);

		if (empty($posts))
			return array();

		// do some conversion
		if($catsort == 'date') { $catsort = 'posterTime'; } 
		elseif($catsort == 'authorID') { $catsort = 'ID_MEMBER'; } 
		elseif($catsort == 'parse' || $catsort == 'id') { $catsort = 'ID_MSG'; } 
		else
			$catsort = 'posterTime'; 

		$request =  tp_query("
			SELECT 
			m.subject,  " . ($context['TPortal']['frontpage_limit_len']>0 ? "LEFT(m.body," . $context['TPortal']['frontpage_limit_len'] . ") as body" : "m.body") . ", 
			IFNULL(mem.realName, m.posterName) AS realName, m.posterTime as date, mem.avatar,mem.posts, mem.dateRegistered,mem.lastLogin,
			IFNULL(a.ID_ATTACH, 0) AS ID_ATTACH, a.filename, a.attachmentType, t.ID_BOARD as category, b.name as category_name,
			t.numReplies, t.ID_TOPIC as id, m.ID_MEMBER as authorID, t.numViews as views,t.numReplies as replies, t.locked,
			IFNULL(thumb.ID_ATTACH, 0) AS thumb_id, thumb.filename as thumb_filename
			FROM (" . $db_prefix . "topics AS t, " . $db_prefix . "messages AS m)
			LEFT JOIN " . $db_prefix . "members AS mem ON (mem.ID_MEMBER = m.ID_MEMBER)
			LEFT JOIN " . $db_prefix . "attachments AS a ON (a.ID_MEMBER = m.ID_MEMBER)
			LEFT JOIN " . $db_prefix . "attachments AS thumb ON (t.ID_FIRST_MSG = thumb.ID_MSG AND thumb.attachmentType = 3)
			LEFT JOIN " . $db_prefix . "boards AS b ON (b.ID_BOARD = t.ID_BOARD)
			WHERE t.ID_FIRST_MSG IN (" . implode(', ', $posts) . ")
			AND m.ID_MSG = t.ID_FIRST_MSG
			ORDER BY m." . $catsort . " DESC
			LIMIT " . $start . "," . $max, __FILE__, __LINE__);
	
		// make the pageindex!
		$context['TPortal']['pageindex'] = TPageIndex($scripturl .'?frontpage', $start, count($posts), $max);
		
		if(tpdb_num_rows($request)>0)
		{
			$total = tpdb_num_rows($request); $col1 = ceil($total/2);
			$col2 = $total - $col1; $counter=0;

			$context['TPortal']['category'] = array(
				'articles' => array(),
				'col1' => array(),
				'col2' => array(),
				'options' => array(
					'catlayout' => $context['TPortal']['frontpage_catlayout'],
					)
				);

			while($row = tpdb_fetch_assoc($request))
			{
				// some needed addons
				$row['rendertype'] = 'bbc';
				$row['frame'] = 'theme';
				$row['boardnews'] = 1;
				if(!isset($context['TPortal']['frontpage_visopts'])) 
					$context['TPortal']['frontpage_visopts'] = 'date,title,author,views' . ($context['TPortal']['forumposts_avatar'] == 1 ? ',avatar' : '');				
				
				$row['visual_options'] = explode(",", $context['TPortal']['frontpage_visopts']);
				$row['useintro'] = '0';
				$row['avatar'] = $row['avatar'] == '' ? ($row['ID_ATTACH'] > 0 ? '<img src="' . (empty($row['attachmentType']) ? $scripturl . '?action=dlattach;attach=' . $row['ID_ATTACH'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) . '" alt="&nbsp;"  />' : '') : (stristr($row['avatar'], 'http://') ? '<img src="' . $row['avatar'] . '" alt="&nbsp;" />' : '<img src="' . $modSettings['avatar_url'] . '/' . $func['htmlspecialchars']($row['avatar']) . '" alt="&nbsp;" />');

				if(!empty($row['thumb_id']))
					$row['illustration'] = $scripturl . '?action=tpmod;sa=tpattach;topic=' . $row['id'] . '.0;attach=' . $row['thumb_id'] . ';image';

				if($counter == 0)
					$context['TPortal']['category']['featured'] = $row;
				elseif($counter < $col1 && $counter>0)
					$context['TPortal']['category']['col1'][] = $row;
				elseif($counter > $col1 || $counter == $col1)
					$context['TPortal']['category']['col2'][] = $row;

				$counter++;						
			}
			tpdb_free_result($request);
		}
	}
	elseif(in_array($context['TPortal']['front_type'], array('forum_articles', 'forum_selected_articles')))
	{
		// first, get all available
		if(!$context['user']['is_admin'])
			$artgroups = 'AND (FIND_IN_SET(' . implode(', var.value3) OR FIND_IN_SET(', $user_info['groups']) . ', var.value3))';
		else
			$artgroups = '';
		
		$totalmax = 200;
		loadLanguage('Stats');
		$year = 10000000;
		$year2 = 100000000;
		
		$request =  tp_query("SELECT art.id, art.date, art.sticky, art.featured
			FROM (" . $tp_prefix . "articles AS art, " . $tp_prefix . "variables AS var) 
			WHERE art.off = 0 
			AND var.id = art.category
			" . $artgroups . "
			AND art.category>0
			AND art.approved = 1 
			AND (art.frontpage = 1 OR art.featured = 1)
			ORDER BY art.featured DESC, art.sticky desc, art.date desc", __FILE__, __LINE__);

		$articles_total = 0;
		$posts = array();
		if(tpdb_num_rows($request)>0)
		{
			$articles_total  = tpdb_num_rows($request);
			while ($row = tpdb_fetch_assoc($request))
			{
				if($row['sticky']==1)
					$row['date'] += $year;
				if($row['featured']==1)
					$row['date'] += $year2;

				$posts[$row['date'].'_' . sprintf("%06s", $row['id'])] = 'a_' . $row['id'];
			}
			tpdb_free_result($request);
		}	
		// Find the post ids.
		if($context['TPortal']['front_type'] == 'forum_articles')
			$request =  tp_query("
			SELECT t.ID_FIRST_MSG, m.posterTime as date
			FROM (" . $db_prefix . "topics as t, " . $db_prefix . "boards as b, " . $db_prefix . "messages as m)
			WHERE t.ID_BOARD=b.ID_BOARD
			AND t.ID_FIRST_MSG = m.ID_MSG
			AND t.ID_BOARD IN(" . $context['TPortal']['SSI_board'] .")
			" . ($context['TPortal']['allow_guestnews']==0 ? 'AND ' . $user_info['query_see_board'] : '') . "
			ORDER BY date DESC
			LIMIT " . $totalmax, __FILE__, __LINE__);
		else
			$request =  tp_query("
			SELECT t.ID_FIRST_MSG , m.posterTime as date
			FROM (" . $db_prefix . "topics as t, " . $db_prefix . "boards as b, " . $db_prefix . "messages as m)
			WHERE t.ID_BOARD=b.ID_BOARD
			AND t.ID_FIRST_MSG = m.ID_MSG
			AND t.ID_TOPIC IN(" . (empty($context['TPortal']['frontpage_topics']) ? '0' : $context['TPortal']['frontpage_topics']) .")
			" . ($context['TPortal']['allow_guestnews']==0 ? 'AND ' . $user_info['query_see_board'] : '') . "
			ORDER BY date DESC
			" , __FILE__, __LINE__);

		if(tpdb_num_rows($request)>0)
		{
			while ($row = tpdb_fetch_assoc($request))
				$posts[$row['date'].'_' . sprintf("%06s", $row['ID_FIRST_MSG'])] = 'm_' . $row['ID_FIRST_MSG'];
			tpdb_free_result($request);
		}

		// which should we select
		$aposts = array(); $mposts = array(); $a=0;
		foreach($posts as $ab => $val)
		{
			if(($a==$start || $a>$start) && $a<($start+$max))
			{
				if(substr($val,0,2) == 'a_')
					$aposts[] = substr($val,2);
				elseif(substr($val,0,2) == 'm_')
					$mposts[] = substr($val,2);
			}
			$a++;
		}

		$thumbs=array();
		if(count($mposts)>0)
		{
			// Find the thumbs.
			$request =  tp_query("SELECT ID_THUMB FROM " . $db_prefix . "attachments
				WHERE ID_MSG IN (" . implode(',', $mposts) . ") and ID_THUMB > 0" , __FILE__, __LINE__);

			if(tpdb_num_rows($request)>0)
			{
			while ($row = tpdb_fetch_assoc($request))
				$thumbs[] = $row['ID_THUMB'];
			tpdb_free_result($request);
			}
		}
		// make the pageindex!
		$context['TPortal']['pageindex'] = TPageIndex($scripturl .'?frontpage', $start, $articles_total + count($posts), $max);

		// ok we got the post ids now, fetch each one, forum first
		if(count($mposts)>0)
			$request =  tp_query("
			SELECT 
			m.subject, " . ($context['TPortal']['frontpage_limit_len']>0 ? "LEFT(m.body," . $context['TPortal']['frontpage_limit_len'] . ") as body" : "m.body") . ", IFNULL(mem.realName, m.posterName) AS realName, m.posterTime as date, mem.avatar,mem.posts, mem.dateRegistered,mem.lastLogin,
			IFNULL(a.ID_ATTACH, 0) AS ID_ATTACH, a.filename, a.attachmentType, t.ID_BOARD as category, b.name as category_name,
			t.numReplies, t.ID_TOPIC as id, m.ID_MEMBER as authorID, t.numViews as views,t.numReplies as replies, t.locked,
			IFNULL(thumb.ID_ATTACH, 0) AS thumb_id, thumb.filename as thumb_filename
			FROM (" . $db_prefix . "topics AS t, " . $db_prefix . "messages AS m)
			LEFT JOIN " . $db_prefix . "members AS mem ON (mem.ID_MEMBER = m.ID_MEMBER)
			LEFT JOIN " . $db_prefix . "attachments AS a ON (a.ID_MEMBER = m.ID_MEMBER)
			LEFT JOIN " . $db_prefix . "attachments AS thumb ON (t.ID_FIRST_MSG = thumb.ID_MSG AND thumb.attachmentType = 3)
			LEFT JOIN " . $db_prefix . "boards AS b ON (b.ID_BOARD = t.ID_BOARD)
			WHERE t.ID_FIRST_MSG IN (" . implode(', ', $mposts) . ")
			AND m.ID_MSG = t.ID_FIRST_MSG
				ORDER BY date DESC, thumb.ID_ATTACH ASC", __FILE__, __LINE__);
		
		$context['TPortal']['category'] = array(
			'articles' => array(),
			'col1' => array(),
			'col2' => array(),
			'options' => array(
				'catlayout' => $context['TPortal']['frontpage_catlayout'],
				'layout' => $context['TPortal']['frontpage_layout'],
				),
			'category_opts' => array(
				'catlayout' => $context['TPortal']['frontpage_catlayout'],
				'template' => $context['TPortal']['frontpage_template'],
				)
			);

		unset($posts); $posts = array();

		// insert the forumposts into $posts
		if(is_resource($request) && tpdb_num_rows($request)>0)
		{
			while($row = tpdb_fetch_assoc($request))
			{
				// some needed addons
				$row['rendertype'] = 'bbc';
				$row['frame'] = 'theme';
				$row['boardnews'] = 1;
				if(!isset($context['TPortal']['frontpage_visopts'])) 
					$context['TPortal']['frontpage_visopts'] = 'date,title,author,views' . ($context['TPortal']['forumposts_avatar'] == 1 ? ',avatar' : '');				
				
				$row['visual_options'] = explode(",", $context['TPortal']['frontpage_visopts']);
				$row['useintro'] = '0';
				$row['avatar'] = $row['avatar'] == '' ? ($row['ID_ATTACH'] > 0 ? '<img src="' . (empty($row['attachmentType']) ? $scripturl . '?action=dlattach;attach=' . $row['ID_ATTACH'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) . '" alt="&nbsp;"  />' : '') : (stristr($row['avatar'], 'http://') ? '<img src="' . $row['avatar'] . '" alt="&nbsp;" />' : '<img src="' . $modSettings['avatar_url'] . '/' . $func['htmlspecialchars']($row['avatar']) . '" alt="&nbsp;" />');

				if(!empty($row['thumb_id']))
					$row['illustration'] = $scripturl . '?action=tpmod;sa=tpattach;topic=' . $row['id'] . '.0;attach=' . $row['thumb_id'] . ';image';
				
				$posts[$row['date'].'0' . sprintf("%06s", $row['id'])] = $row;
			}
			tpdb_free_result($request);
		}
		// next up is articles
		if(count($aposts)>0)
		{
			$request =  tp_query("SELECT art.id, IF(art.useintro>0, art.intro, art.body) AS body,
			art.date, art.category, art.subject, art.authorID, var.value1 as category_name,
			art.frame, art.comments, art.options, art.intro, art.useintro, art.sticky, art.featured,
			art.comments_var, art.views, art.rating, art.voters, art.shortname,
			art.fileimport, art.topic, art.illustration,art.type as rendertype ,art.global_tag,
			IFNULL(mem.realName, art.author) as realName, mem.avatar, mem.posts, mem.dateRegistered,mem.lastLogin,
			IFNULL(a.ID_ATTACH, 0) AS ID_ATTACH, a.filename, a.attachmentType
			FROM " . $tp_prefix . "articles AS art
			LEFT JOIN " . $tp_prefix . "variables AS var ON(var.id = art.category) 
			LEFT JOIN " . $db_prefix . "members AS mem ON (art.authorID = mem.ID_MEMBER)
			LEFT JOIN " . $db_prefix . "attachments AS a ON (a.ID_MEMBER = mem.ID_MEMBER)
			WHERE art.id IN (" . implode(', ', $aposts) . ")
			ORDER BY art.featured desc, art.sticky desc, art." . $catsort ." " . $catsort_order , __FILE__, __LINE__);
			if(tpdb_num_rows($request)>0)
			{
				while($row = tpdb_fetch_assoc($request))
				{
					// expand the vislaoptions
					$row['visual_options'] = explode(",", $row['options']);
					$row['visual_options']['layout'] = $context['TPortal']['frontpage_layout'];
					
					$row['avatar'] = $row['avatar'] == '' ? ($row['ID_ATTACH'] > 0 ? '<img src="' . (empty($row['attachmentType']) ? $scripturl . '?action=dlattach;attach=' . $row['ID_ATTACH'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) . '" alt="&nbsp;"  />' : '') : (stristr($row['avatar'], 'http://') ? '<img src="' . $row['avatar'] . '" alt="&nbsp;" />' : '<img src="' . $modSettings['avatar_url'] . '/' . $func['htmlspecialchars']($row['avatar']) . '" alt="&nbsp;" />');
					
				$row['body'] = html_entity_decode($row['body'], ENT_QUOTES);
				$row['intro'] = html_entity_decode($row['intro'], ENT_QUOTES);
				$row['subject'] = html_entity_decode($row['subject'], ENT_QUOTES);
				$row['category_name'] = html_entity_decode($row['category_name'], ENT_QUOTES);
					// we need some trick to put featured/sticky on top
					$sortdate = $row['date'];
					if($row['sticky']==1)
						$sortdate = $row['date'] + $year;
					if($row['featured']==1)
						$sortdate = $row['date'] + $year+$year;
					
					$posts[$sortdate.'0' . sprintf("%06s", $row['id'])] = $row;
				}
				tpdb_free_result($request);
			}
		}	
		$total = count($posts); $col1 = ceil($total/2);
		$col2 = $total - $col1; $counter=0;
		$counter = 0;
		
		// divide it
		ksort($posts,SORT_NUMERIC);
		$all = array_reverse($posts);
		
		foreach($all as $p => $row)
		{
			if($counter == 0)
				$context['TPortal']['category']['featured'] = $row;
			elseif($counter < $col1 && $counter>0)
				$context['TPortal']['category']['col1'][] = $row;
			elseif($counter > $col1 || $counter == $col1)
				$context['TPortal']['category']['col2'][] = $row;
			$counter++;						
		}
	}

	// collect up frontblocks
	$blocks=array('front' => '');
	$blocktype=array('no','userbox','newsbox','statsbox','searchbox','html',
		'onlinebox','themebox','oldshoutbox','catmenu','phpbox','scriptbox','recentbox',
		'ssi','module','rss','sitemap','oldadmin','articlebox','categorybox','tpmodulebox');

	// set the membergroup access
	$mygroups = $user_info['groups'];
	$access = '(FIND_IN_SET(' . implode(', access) OR FIND_IN_SET(', $mygroups) . ', access))';

    if(allowedTo('tp_blocks') && (!empty($context['TPortal']['admin_showblocks']) || !isset($context['TPortal']['admin_showblocks'])))
		$access = '1';
        
	// get the blocks
	$request =  tp_query("SELECT * FROM 
		" . $tp_prefix . "blocks 
		WHERE off=0 
		AND bar = 4
		AND " . $access . "
		ORDER BY pos,id ASC ", __FILE__, __LINE__);

	$count = array('front' => 0); 
	$fetch_articles=array(); 
    $fetch_article_titles = array();
    $panels = array(4 => 'front');
    
	if (tpdb_num_rows($request) > 0)
	{
		while($row = tpdb_fetch_assoc($request))
		{
			// some tests to minimize sql calls
			if($row['type'] == 7)
				$test_themebox = true;
			elseif($row['type'] == 18)
			{
				$test_articlebox = true;
				if(is_numeric($row['body']))
					$fetch_articles[]=$row['body'];
			}
			elseif($row['type'] == 9)
				$test_menubox = true;
			elseif($row['type'] == 19)
			{
				$test_catbox = true;
				if(is_numeric($row['body']))
					$fetch_article_titles[]=$row['body'];
			}
			// for modules, include it now
			elseif($row['type'] == 20)
			{
				if(!empty($context['TPortal']['tpmodules']['blockrender'][$row['var1']]['sourcefile']) && file_exists($context['TPortal']['tpmodules']['blockrender'][$row['var1']]['sourcefile']))
					require_once($context['TPortal']['tpmodules']['blockrender'][$row['var1']]['sourcefile']);
			}
			$can_edit = get_perm($row['editgroups'],'');
			$can_manage = allowedTo('tp_blocks');
			if($can_manage)
				$can_edit = false; 

			if($row['type']==5 || $row['type']==11)
				$body=html_entity_decode($row['body'], ENT_QUOTES);
			else
				$body=$row['body'];

			$blocks[$panels[$row['bar']]][$count[$panels[$row['bar']]]] = array(
				'frame' => $row['frame'],
				'title' => strip_tags(html_entity_decode($row['title'], ENT_QUOTES), '<center>'),
				'type' => $blocktype[$row['type']],
				'body' => $body ,
				'visible' => $row['visible'],
				'var1' => $row['var1'],
				'var2' => $row['var2'],
				'var3' => $row['var3'],
				'var4' => $row['var4'],
				'id' => $row['id'],
				'lang' => $row['lang'],
				'access2' => $row['access2'],
				'can_edit' => $can_edit,
				'can_manage' => $can_manage,
				);

			$count[$panels[$row['bar']]]++;
		}
		tpdb_free_result($request);
	}
	if(sizeof($fetch_articles)>0)
		$fetchart= '(art.id='. implode(' OR art.id=', $fetch_articles).')';
	else
		$fetchart='';

	if(sizeof($fetch_article_titles)>0)
		$fetchtitles= '(art.category='. implode(' OR art.category=', $fetch_article_titles).')';
	else
		$fetchtitles='';

    // if a block displays an article
    if(isset($test_articlebox) && $fetchart!='')
	{
		$context['TPortal']['blockarticles'] = array();
		$request =  tp_query("SELECT art.*, var.value1,var.value2,var.value3,var.value4, var.value5,var.value7,var.value8, art.type as rendertype, 
		IFNULL(mem.realName,art.author) as realName, mem.avatar, mem.posts, mem.dateRegistered,mem.lastLogin,
		IFNULL(a.ID_ATTACH, 0) AS ID_ATTACH, a.filename, a.attachmentType, var.value9 
		FROM " . $tp_prefix . "articles as art 
		LEFT JOIN " . $db_prefix . "members AS mem ON (mem.ID_MEMBER = art.authorID)
		LEFT JOIN " . $db_prefix . "attachments AS a ON (a.ID_MEMBER = art.authorID)
		LEFT JOIN " . $tp_prefix . "variables as var ON (var.id= art.category) 
		WHERE " . $fetchart." 
		AND art.off=0 
		AND art.category>0
		AND art.approved=1 
		AND art.category>0 AND art.category<9999	", __FILE__, __LINE__);
		if(tpdb_num_rows($request)>0)
		{
			while($article = tpdb_fetch_assoc($request))
			{
				$article['body'] = html_entity_decode($article['body'], ENT_QUOTES);
				$article['intro'] = html_entity_decode($article['intro'], ENT_QUOTES);
				$article['subject'] = html_entity_decode($article['subject'], ENT_QUOTES);
				$article['value1'] = html_entity_decode($article['value1'], ENT_QUOTES);
				// allowed and all is well, go on with it.
				$context['TPortal']['blockarticles'][$article['id']] = $article;

				$context['TPortal']['blockarticles'][$article['id']]['avatar'] = $row['avatar'] == '' ? ($row['ID_ATTACH'] > 0 ? '<img src="' . (empty($row['attachmentType']) ? $scripturl . '?action=dlattach;attach=' . $row['ID_ATTACH'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) . '" alt="&nbsp;"  />' : '') : (stristr($row['avatar'], 'http://') ? '<img src="' . $row['avatar'] . '" alt="&nbsp;" />' : '<img src="' . $modSettings['avatar_url'] . '/' . $func['htmlspecialchars']($row['avatar']) . '" alt="&nbsp;" />');
				
				// sort out the options
				$context['TPortal']['blockarticles'][$article['id']]['visual_options'] = array();
				// since these are inside blocks, some stuff has to be left out
				$context['TPortal']['blockarticles'][$article['id']]['frame'] = 'none';
			}
			tpdb_free_result($request);
		}
	}

   // any cat listings from blocks?
    if(isset($test_catbox) && $fetchtitles!='')
	{
		$request =  tp_query("SELECT art.id, art.subject, art.date, art.category, art.authorID, art.shortname,
		IFNULL(mem.realName,art.author) as realName FROM " . $tp_prefix . "articles AS art
		LEFT JOIN " . $db_prefix . "members AS mem ON (art.authorID = mem.ID_MEMBER) 
		WHERE " . 	$fetchtitles . "
		AND art.off=0
		AND art.category>0
		AND art.approved=1", __FILE__, __LINE__);

		if (!$context['TPortal']['blockarticle_titles']){
			$context['TPortal']['blockarticle_titles'] = array();
		}
		if (tpdb_num_rows($request) > 0)
		{
			while($row = tpdb_fetch_assoc($request))
			{
				$context['TPortal']['blockarticle_titles'][$row['category']][$row['date'].'_'.$row['id']] = array(
					'id' => $row['id'],
					'subject' => html_entity_decode($row['subject'], ENT_QUOTES),
					'shortname' => $row['shortname']!='' ?$row['shortname'] : $row['id'] ,
					'category' => $row['category'],
					'poster' => '<a href="'.$scripturl.'?action=profile;u='.$row['authorID'].'">'.$row['realName'].'</a>',
				);
			}
			tpdb_free_result($request);
		}
    }
	// get menubox items
	if(isset($test_menubox))
	{
		$context['TPortal']['menu']=array();
		$request =  tp_query("SELECT * FROM " . $tp_prefix . "variables WHERE type='menubox' ORDER BY value5 ASC ", __FILE__, __LINE__);
		if(tpdb_num_rows($request)>0)
		{
			while ($row = tpdb_fetch_assoc($request))
			{
				$icon='';
				if($row['value5']!=-1 && $row['value2']!='-1')
				{
					$mtype=substr($row['value3'],0,4);
					$idtype=substr($row['value3'],4);
					if($mtype!='cats' && $mtype!='arti' && $mtype!='head' && $mtype!='spac')
					{
						$mtype='link';
						$idtype=$row['value3'];
					}
					if($mtype=='cats')
					{
						if(isset($context['TPortal']['article_categories']['icon'][$idtype]))
							$icon=$context['TPortal']['article_categories']['icon'][$idtype];
					}
					if($mtype=='head')
					{
						$mtype='head';
						$idtype=$row['value1'];
					}
					$menupos=$row['value5'];

					$context['TPortal']['menu'][$row['subtype2']][] = array(
						'id' => $row['id'],
						'menuID' => $row['subtype2'],
						'name' => html_entity_decode($row['value1'], ENT_QUOTES),
						'pos' => $menupos,
						'type' => $mtype,
						'IDtype' => $idtype,
						'off' => '0',
						'sub' => $row['value4'],
						'icon' => $icon,
						'newlink' => $row['value2'],
						'sitemap' => (in_array($row['id'],$context['TPortal']['sitemap'])) ? true : false,
						);
				}
			}
			tpdb_free_result($request);
		}
		// get menubox rendertypes
		$context['TPortal']['menurender']=array();
		$request =  tp_query("SELECT * FROM " . $tp_prefix . "variables WHERE type='menutype' ORDER BY value5 ASC ", __FILE__, __LINE__);
		if(tpdb_num_rows($request)>0)
		{
			while ($row = tpdb_fetch_assoc($request))
			{
				$context['TPortal']['menurender'][$row['id']] = array(
						'id' => $row['id'],
						'name' => html_entity_decode($row['value1'], ENT_QUOTES),
						);
			}
			tpdb_free_result($request);
		}
	}

	// check the panels
	foreach($panels as $p => $panel)
	{
		// any blocks at all?
		if($count[$panel]<1)
			$context['TPortal'][$panel.'panel'] = 0;

	}
	
	$context['TPortal']['frontblocks'] = $blocks;

	if (WIRELESS)
	{
		$context['TPortal']['single_article'] = false;
		loadtemplate('TPwireless');
		// decide what subtemplate
		$context['sub_template'] = WIRELESS_PROTOCOL . '_tp_frontpage';
	}
}

// do the blocks
function doTPblocks()
{
	global $db_prefix, $tp_prefix, $context, $scripturl, $txt, $user_info, $settings;
	global $func, $modSettings, $ID_MEMBER, $boarddir, $boardurl, $sourcedir, $language;

	$tp_prefix = $settings['tp_prefix'];

	// setup the containers
	$blocks=array('left' => '', 'right' => '', 'center' => '', 'front' => '', 'bottom' => '', 'top' => '' , 'lower' => '');
	$blocktype=array('no','userbox','newsbox','statsbox','searchbox','html',
		'onlinebox','themebox','oldshoutbox','catmenu','phpbox','scriptbox','recentbox',
		'ssi','module','rss','sitemap','oldadmin','articlebox','categorybox','tpmodulebox');

	// construct the spot we are in
	$sqlarray = array();
	// any action?
	if(!empty($_GET['action']))
	{
		$sqlarray[] = 'actio=' . $_GET['action'];
		if(in_array($_GET['action'], array('forum','collapse','post','calendar','search','login','logout','register','unread','unreadreplies','recent','stats','pm','profile','post2','search2','login2')))
			$sqlarray[] = 'actio=forumall';
	}
	// page?
	if(!empty($_GET['page']))
	{
		if(!empty($context['shortID']))
			$sqlarray[] = 'tpage=' . $context['shortID'];
		else
			$sqlarray[] = 'tpage=' . $_GET['page'];
	}
	if(!empty($_GET['cat']) && !isset($_GET['action']))
	{
		if(!empty($context['catshortID']))
			$sqlarray[] = 'tpcat=' . $context['catshortID'];
		else
			$sqlarray[] = 'tpcat=' . $_GET['cat'];
	}
	if(!empty($_GET['board']))
	{
		if(!isset($_GET['action']))
			$sqlarray[] = 'board=-1';
		$sqlarray[] = 'board=' . $_GET['board'];
		$sqlarray[] = 'actio=forumall';
	}
	if(!empty($_GET['topic']))
	{
		if(!isset($_GET['action']))
			$sqlarray[] = 'board=-1';
		$sqlarray[] = 'topic=' . $_GET['topic'];
		$sqlarray[] = 'actio=forumall';
	}
	// frontpage
	if(!isset($_GET['action']) && !isset($_GET['board']) && !isset($_GET['topic']) && !isset($_GET['page']) && !isset($_GET['cat']))
		$sqlarray[] = 'actio=frontpage';
	
	$sqlarray[] = 'actio=allpages';

	// any languages, but only if the option is set
	if(!empty($context['TPortal']['uselangoption']))
		$lang = 'AND FIND_IN_SET(\'tlang='.$user_info['language'].'\', access2)';
	else
		$lang='';
	
	// set the location access
	$access2 = '(FIND_IN_SET(\'' . implode('\', access2) OR FIND_IN_SET(\'', $sqlarray) . '\', access2))';

	// set the membergroup access
	$mygroups = $user_info['groups'];
	$access = '(FIND_IN_SET(' . implode(', access) OR FIND_IN_SET(', $mygroups) . ', access))';

	if(allowedTo('tp_blocks') && (!empty($context['TPortal']['admin_showblocks']) || !isset($context['TPortal']['admin_showblocks'])))
		$access = '1';
	
	// get the blocks
	$request =  tp_query("SELECT * FROM 
		" . $tp_prefix . "blocks 
		WHERE off=0 
		AND bar != 4
		AND " . $access2 . "
		AND " . $access . "
		" . $lang . "
		ORDER BY bar,pos,id ASC", __FILE__, __LINE__);

	$context['TPortal']['hide_frontbar_forum']=0;
	$count = array('left' => 0, 'right' => 0, 'center' => 0, 'front' => 0, 'bottom' => 0, 'top' => 0, 'lower' => 0); 
	
	$fetch_articles=array(); $fetch_article_titles = array();

	$panels = array(1 => 'left', 2 => 'right', 3 => 'center', 4 => 'front', 5 => 'bottom', 6 => 'top', 7 => 'lower');
	if (tpdb_num_rows($request) > 0)
	{
		while($row = tpdb_fetch_assoc($request))
		{
			// some tests to minimize sql calls
			if($row['type'] == 7)
				$test_themebox = true;
			elseif($row['type'] == 18)
			{
				$test_articlebox = true;
				if(is_numeric($row['body']))
					$fetch_articles[]=$row['body'];
			}
			elseif($row['type'] == 9 || $row['type'] == 16  )
				$test_menubox = true;
			elseif($row['type'] == 19)
			{
				$test_catbox = true;
				if(is_numeric($row['body']))
					$fetch_article_titles[]=$row['body'];
			}
			// for modules, include it now
			elseif($row['type'] == 20)
			{
				if(!empty($context['TPortal']['tpmodules']['blockrender'][$row['var1']]['sourcefile']) && file_exists($context['TPortal']['tpmodules']['blockrender'][$row['var1']]['sourcefile']))
					require_once($context['TPortal']['tpmodules']['blockrender'][$row['var1']]['sourcefile']);
			}
			$can_edit = !empty($row['editgroups']) ? get_perm($row['editgroups'],'') : false;
			$can_manage = allowedTo('tp_blocks');
			if($can_manage)
				$can_edit = false; 

			$body=html_entity_decode($row['body'], ENT_QUOTES);

			$blocks[$panels[$row['bar']]][$count[$panels[$row['bar']]]] = array(
				'frame' => $row['frame'],
				'title' => strip_tags(html_entity_decode($row['title'], ENT_QUOTES)),
				'type' => isset($blocktype[$row['type']]) ? $blocktype[$row['type']] : $row['type'],
				'body' => $body ,
				'visible' => $row['visible'],
				'var1' => $row['var1'],
				'var2' => $row['var2'],
				'var3' => $row['var3'],
				'var4' => $row['var4'],
				'id' => $row['id'],
				'lang' => $row['lang'],
				'access2' => $row['access2'],
				'can_edit' => $can_edit,
				'can_manage' => $can_manage,
				);

			$count[$panels[$row['bar']]]++;
		}
		tpdb_free_result($request);
	}
	if(sizeof($fetch_articles)>0)
		$fetchart= '(art.id='. implode(' OR art.id=', $fetch_articles).')';
	else
		$fetchart='';

	if(sizeof($fetch_article_titles)>0)
		$fetchtitles= '(art.category='. implode(' OR art.category=', $fetch_article_titles).')';
	else
		$fetchtitles='';

    // if a block displays an article
    if(isset($test_articlebox) && $fetchart!='')
	{
		$context['TPortal']['blockarticles'] = array();
		$request =  tp_query("SELECT art.*, var.value1,var.value2,var.value3,var.value4, var.value5,var.value7,var.value8, art.type as rendertype, 
		IFNULL(mem.realName,art.author) as realName, mem.avatar, mem.posts, mem.dateRegistered,mem.lastLogin,
		IFNULL(a.ID_ATTACH, 0) AS ID_ATTACH, a.filename, a.attachmentType, var.value9 
		FROM " . $tp_prefix . "articles as art 
		LEFT JOIN " . $db_prefix . "members AS mem ON (mem.ID_MEMBER = art.authorID)
		LEFT JOIN " . $db_prefix . "attachments AS a ON (a.ID_MEMBER = art.authorID)
		LEFT JOIN " . $tp_prefix . "variables as var ON (var.id= art.category) 
		WHERE " . $fetchart." 
		AND art.off=0 
		AND art.approved=1 
		AND art.category>0 AND art.category<9999	", __FILE__, __LINE__);
		if(tpdb_num_rows($request)>0)
		{
			while($article = tpdb_fetch_assoc($request))
			{
				$article['subject'] = html_entity_decode($article['subject'], ENT_QUOTES);
				$article['value1'] = html_entity_decode($article['value1'], ENT_QUOTES);
				$article['body'] = html_entity_decode($article['body'], ENT_QUOTES);
				// allowed and all is well, go on with it.
				$context['TPortal']['blockarticles'][$article['id']] = $article;

				// setup the avatar code
				if ($modSettings['avatar_action_too_large'] == 'option_html_resize' || $modSettings['avatar_action_too_large'] == 'option_js_resize')
				{
					$avatar_width = !empty($modSettings['avatar_max_width_external']) ? ' width="' . $modSettings['avatar_max_width_external'] . '"' : '';
					$avatar_height = !empty($modSettings['avatar_max_height_external']) ? ' height="' . $modSettings['avatar_max_height_external'] . '"' : '';
				}
				else
				{
					$avatar_width = '';
					$avatar_height = '';
				}
				$context['TPortal']['blockarticles'][$article['id']]['avatar'] = $article['avatar'] == '' ? ($article['ID_ATTACH'] > 0 ? '<img src="' . (empty($article['attachmentType']) ? $scripturl . '?action=tpmod;sa=tpattach;attach=' . $article['ID_ATTACH'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $article['filename']) . '" alt="" class="avatar" border="0" />' : '') : (stristr($article['avatar'], 'http://') ? '<img src="' . $article['avatar'] . '"' . $avatar_width . $avatar_height . ' alt="" class="avatar" border="0" />' : '<img src="' . $modSettings['avatar_url'] . '/' . $func['htmlspecialchars']($article['avatar']) . '" alt="" class="avatar" border="0" />');
				
				// sort out the options
				$context['TPortal']['blockarticles'][$article['id']]['visual_options'] = array();
				// since these are inside blocks, some stuff has to be left out
				$context['TPortal']['blockarticles'][$article['id']]['frame'] = 'none';
			}
			tpdb_free_result($request);
		}
	}

   // any cat listings from blocks?
    if(isset($test_catbox) && $fetchtitles!='')
	{
		$request =  tp_query("SELECT art.id, art.subject, art.date, art.category, art.authorID, art.shortname,
		IFNULL(mem.realName,art.author) as realName FROM " . $tp_prefix . "articles AS art
		LEFT JOIN " . $db_prefix . "members AS mem ON (art.authorID = mem.ID_MEMBER) 
		WHERE " . 	$fetchtitles . "
		AND art.off=0
		AND art.approved=1", __FILE__, __LINE__);

		$context['TPortal']['blockarticle_titles']=array();
		if (tpdb_num_rows($request) > 0)
		{
			while($row = tpdb_fetch_assoc($request))
			{
				$context['TPortal']['blockarticle_titles'][$row['category']][$row['date'].'_'.$row['id']] = array(
					'id' => $row['id'],
					'subject' => html_entity_decode($row['subject'], ENT_QUOTES),
					'shortname' => $row['shortname']!='' ?$row['shortname'] : $row['id'] ,
					'category' => $row['category'],
					'poster' => '<a href="'.$scripturl.'?action=profile;u='.$row['authorID'].'">'.$row['realName'].'</a>',
				);
			}
			tpdb_free_result($request);
		}
    }
	// get menubox items
	if(isset($test_menubox))
	{
		$context['TPortal']['menu']=array();
		$request =  tp_query("SELECT * FROM " . $tp_prefix . "variables WHERE type='menubox' ORDER BY subtype + 0 ASC ", __FILE__, __LINE__);
		if(tpdb_num_rows($request)>0)
		{
			while ($row = tpdb_fetch_assoc($request))
			{
				$icon='';
				if($row['value5']<1)
				{
					$mtype=substr($row['value3'],0,4);
					$idtype=substr($row['value3'],4);
					if($mtype!='cats' && $mtype!='arti' && $mtype!='head' && $mtype!='spac')
					{
						$mtype='link';
						$idtype=$row['value3'];
					}
					if($mtype=='cats')
					{
						if(isset($context['TPortal']['article_categories']['icon'][$idtype]))
							$icon=$context['TPortal']['article_categories']['icon'][$idtype];
					}
					if($mtype=='head')
					{
						$mtype='head';
						$idtype=$row['value1'];
					}
					$menupos=$row['value5'];

					$context['TPortal']['menu'][$row['subtype2']][] = array(
						'id' => $row['id'],
						'menuID' => $row['subtype2'],
						'name' => html_entity_decode($row['value1'], ENT_QUOTES),
						'pos' => $menupos,
						'type' => $mtype,
						'IDtype' => $idtype,
						'off' => '0',
						'sub' => $row['value4'],
						'icon' => $icon,
						'newlink' => $row['value2'],
						'sitemap' => (in_array($row['id'],$context['TPortal']['sitemap'])) ? true : false,
						);
				}
			}
			tpdb_free_result($request);
		}
		// get menubox rendertypes
		$context['TPortal']['menurender']=array();
		$request =  tp_query("SELECT * FROM " . $tp_prefix . "variables WHERE type='menutype' ORDER BY value5 ASC ", __FILE__, __LINE__);
		if(tpdb_num_rows($request)>0)
		{
			while ($row = tpdb_fetch_assoc($request))
			{
				$context['TPortal']['menurender'][$row['id']] = array(
						'id' => $row['id'],
						'name' => html_entity_decode($row['value1'], ENT_QUOTES),
						);
			}
			tpdb_free_result($request);
		}
	}

	// for tpadmin
	$context['TPortal']['adminleftpanel']=$context['TPortal']['leftpanel'];
	$context['TPortal']['adminrightpanel']=$context['TPortal']['rightpanel'];
	$context['TPortal']['admincenterpanel']=$context['TPortal']['centerpanel'];
	$context['TPortal']['adminbottompanel']=$context['TPortal']['bottompanel'];
	$context['TPortal']['admintoppanel']=$context['TPortal']['toppanel'];
	$context['TPortal']['adminlowerpanel']=$context['TPortal']['lowerpanel'];

	// if admin specifies no blocks, no blocks are shown! likewise, if in admin or tpadmin screen, turn off blocks
	if (in_array($context['TPortal']['action'], array('help','moderate','theme','tpadmin','admin', 'ban', 'boardrecount', 'cleanperms', 'detailedversion', 'dumpdb', 'featuresettings', 'featuresettings2', 'findmember', 'maintain', 'manageattachments', 'manageboards', 'managecalendar', 'managesearch', 'membergroups', 'modlog', 'news', 'optimizetables', 'packageget', 'packages', 'permissions', 'pgdownload', 'postsettings', 'regcenter', 'repairboards', 'reports', 'serversettings', 'serversettings2', 'smileys', 'viewErrorLog', 'viewmembers')))
		$in_admin=true;
	if($context['TPortal']['action']=='tpmod' && isset($_GET['dl']) && substr($_GET['dl'],0,5)=='admin')
	{
		$in_admin=true;
		$context['current_action'] = 'admin';
	}
	if(($context['user']['is_admin'] && isset($_GET['noblocks'])) || ($context['TPortal']['hidebars_admin_only']=='1' && isset($in_admin)))
		tp_hidebars();

	// check the panels
	foreach($panels as $p => $panel)
	{
		// any blocks at all?
		if($count[$panel]<1)
			$context['TPortal'][$panel.'panel'] = 0;

		// check the hide setting
		if(!isset($context['TPortal']['not_forum']) && $context['TPortal']['hide_' . $panel . 'bar_forum']==1)
			tp_hidebars($panel);
	}
	$context['TPortal']['blocks'] = $blocks;
}

// TPortal side bar, left or right.
function TPortal_panel($side)
{
	global $context , $scripturl, $settings, $language , $txt;

	if(function_exists('ctheme_tportal_panel'))
	{
		ctheme_tportal_panel($side);
		return;
	}
	
	// decide for $flow
	$flow = $context['TPortal']['block_layout_' . $side];

	$panelside = $paneltype = ($side == 'front' ? 'frontblocks' : 'blocks');

	$code = '
	<div class="tp_'.$side.'panel"' . ($flow == 'horiz' ? ' style="overflow: hidden;"' : '') . '>';
	// set the grid type
	if($flow == 'grid')
	{
		$grid_selected=$context['TPortal']['blockgrid_' . $side];
		if($grid_selected=='colspan3')
			$grid_recycle=4;
		elseif($grid_selected=='rowspan1')
			$grid_recycle=5;

		$grid_entry=0;
		// fetch the grids..
		TP_blockgrids();
	}
	// check if we left out the px!!
	if(is_numeric($context['TPortal']['blockwidth_'.$side]))
		$context['TPortal']['blockwidth_'.$side] .= 'px';

	// for the cols, calculate numbers
	if($flow == 'horiz2')
	{
		$flowgrid=array(
			'1' => array(1,0),
			'2' => array(1,1),
			'3' => array(2,1),
			'4' => array(2,2),
			'5' => array(3,2),
			'6' => array(3,3),
			'7' => array(4,3),
			'8' => array(4,4),
			'9' => array(5,4),
			'10' => array(5,5),
			'11' => array(6,5),
			'12' => array(6,6),
			'13' => array(7,6),
			'14' => array(7,7),
			'15' => array(8,7),
			'16' => array(8,8),
			);
		$switch=ceil(count($context['TPortal'][$panelside][$side])/2);
	}
	elseif($flow == 'horiz3')
	{
		$flowgrid=array(
			'1' => array(1,0,0),
			'2' => array(1,1,0),
			'3' => array(1,1,1),
			'4' => array(2,1,1),
			'5' => array(2,2,1),
			'6' => array(2,2,2),
			'7' => array(3,2,2),
			'8' => array(3,3,2),
			'9' => array(3,3,3),
			'10' => array(4,3,3),
			'11' => array(4,4,3),
			'12' => array(4,4,4),
			'13' => array(5,4,4),
			'14' => array(5,5,4),
			'15' => array(5,5,5),
			'16' => array(6,5,5),
			);
	}
	elseif($flow == 'horiz4')
	{
		$flowgrid=array(
			'1' => array(1,0,0,0),
			'2' => array(1,1,0,0),
			'3' => array(1,1,1,0),
			'4' => array(1,1,1,1),
			'5' => array(2,1,1,1),
			'6' => array(2,2,1,1),
			'7' => array(2,2,2,1),
			'8' => array(2,2,2,2),
			'9' => array(3,2,2,2),
			'10' => array(3,3,2,2),
			'11' => array(3,3,3,2),
			'12' => array(3,3,3,3),
			'13' => array(4,3,3,3),
			'14' => array(4,4,3,3),
			'15' => array(4,4,4,3),
			'16' => array(4,4,4,4),
			);
		
	}
	if(in_array($flow, array('horiz2','horiz3','horiz4')))
	{
		$pad = $context['TPortal']['padding'];
		if($flow=='horiz2')
			$wh=50;
		elseif($flow=='horiz3')
			$wh=33;
		elseif($flow=='horiz4')
			$wh=25;

		echo '<table cellpadding="0" cellspacing="0" width="100%"><tr><td valign="top" style="' . (isset($wh) ? 'width: '.$wh.'%;' : '' ) . 'padding-right: '.$pad.'px; ">';
	}
	$flowmain=0;
	$flowsub=0;
	$bcount=0;
	$flowcount = isset($context['TPortal'][$panelside][$side]) ? count($context['TPortal'][$panelside][$side]) : 0;
	if(!isset($context['TPortal'][$panelside][$side]))
		$context['TPortal'][$panelside][$side] = array();

	for ($i = 0, $n = count($context['TPortal'][$paneltype][$side]); $i < $n; $i += 1)
	{
		$block =& $context['TPortal'][$panelside][$side][$i];
		if(!isset($block['frame']))
			continue;

		$theme = $block['frame'] == 'theme';

		// check if a language title string exists
		$newtitle = TPgetlangOption($block['lang'], $context['user']['language']);
		if(!empty($newtitle))
			$block['title'] = $newtitle;

		$use=true;
		// special title links and variables for special types
		switch($block['type']){
			case 'searchbox':
				$mp='<a class="subject" href="'.$scripturl.'?action=search">'.$block['title'].'</a>';
				$block['title']=$mp;
				break;
			case 'onlinebox':
				$mp='<a class="subject"  href="'.$scripturl.'?action=who">'.$block['title'].'</a>';
				$block['title']=$mp;
				break;
			case 'userbox':
				if($context['user']['is_logged'])
					$mp='<a class="subject"  href="'.$scripturl.'?action=profile;u='.$context['user']['id'].'">'.$block['title'].'</a>';
				else
					$mp='<a class="subject"  href="'.$scripturl.'?action=login">'.$block['title'].'</a>';
				$block['title']=$mp;
				break;
			case 'statsbox':
				$mp='<a class="subject"  href="'.$scripturl.'?action=stats">'.$block['title'].'</a>';
				$block['title']=$mp;
				break;
			case 'recentbox':
				$mp='<a class="subject"  href="'.$scripturl.'?action=recent">'.$block['title'].'</a>';
				$context['TPortal']['recentboxnum']=$block['body'];
				$context['TPortal']['useavatar']= $block['var1'];
				if($block['var1']=='')
					$context['TPortal']['useavatar'] = 1;
				if(!empty($block['var2']))
					$context['TPortal']['recentbox_options'] = explode(",",$block['var2']);
				break;
			case 'scriptbox':
				$block['title']='<span class="header">' . $block['title'] . '</span>';
				$context['TPortal']['scriptboxbody']=$block['body'];
				break;
			case 'phpbox':
				$block['title']='<span class="header">' . $block['title'] . '</span>';
				$context['TPortal']['phpboxbody']=$block['body'];
				break;
			case 'ssi':
				$block['title']='<span class="header">' . $block['title'] . '</span>';
				$context['TPortal']['ssifunction']= $block['body'];
				break;
			case 'module':
				$block['title']='<span class="header">' . $block['title'] . '</span>';
				$context['TPortal']['moduleblock']= $block['body'];
				$context['TPortal']['modulevar2']=$block['var2'];
				break;
			case 'themebox':
				$block['title']='<span class="header">' . $block['title'] . '</span>';
				$context['TPortal']['themeboxbody']= $block['body'];
				break;
			case 'newsbox':
				$block['title']='<span class="header">' . $block['title'] . '</span>';
				if($context['random_news_line']=='')
					$use=false;
				break;
			case 'articlebox':
				$block['title']='<span class="header">' . $block['title'] . '</span>';
				$context['TPortal']['blockarticle']= $block['body'];
				break;
			case 'rss':
				$block['title']='<span class="header rss">' . $block['title'] . '</span>';
				$context['TPortal']['rss']= $block['body'];
				$context['TPortal']['rss_notitles']= $block['var2'];
				$context['TPortal']['rss_utf8']= $block['var1'];
				$context['TPortal']['rsswidth'] = isset($block['var3']) ? $block['var3'] : '';
				break;
			case 'categorybox':
				$block['title']='<span class="header">' . $block['title'] . '</span>';
				$context['TPortal']['blocklisting']= $block['body'];
				$context['TPortal']['blocklisting_height']= $block['var1'];
				$context['TPortal']['blocklisting_author']= $block['var2'];
				break;
			case 'tpmodulebox':
				$block['title']='<span class="header">' . $block['title'] . '</span>';
				$context['TPortal']['moduleid']=$block['var1'];
				$context['TPortal']['modulevar2']=$block['var2'];
				$context['TPortal']['modulebody']=$block['body'];
				break;
			case 'catmenu':
				$block['title']='<span class="header">' . $block['title'] . '</span>';
				$context['TPortal']['menuid']=is_numeric($block['body']) ? $block['body'] : 0;
				$context['TPortal']['menuvar1']=$block['var1'];
				$context['TPortal']['menuvar2']=$block['var2'];
				$context['TPortal']['blockid']=$block['id'];
				break;
		}
		// render them horisontally
		if($flow == 'horiz')
		{
			$pad = $context['TPortal']['padding'];
			if($i == ($flowcount-1))
				$pad=0;

			echo '<div style="float: left; width: ' . $context['TPortal']['blockwidth_'.$side].';"><div style="padding-right: ' . $pad . 'px; padding-bottom: '.$pad.'px;">'; 
			call_user_func($context['TPortal']['hooks']['tp_block'],$block, $theme, $side);
			echo '</div></div>';
		}
		// render them horisontally
		elseif(in_array($flow, array('horiz2','horiz3','horiz4')))
		{
			$pad = $context['TPortal']['padding'];
			if($i == ($flowcount-1))
				$pad=0;

			if($flow=='horiz2')
				$wh=50;
			elseif($flow=='horiz3')
			{
				if($i == ($flowcount-1))
					$wh=34;
				else			
					$wh=33;
			}
			elseif($flow=='horiz4')
				$wh=25;

			if(isset($flowgrid) && $flowsub==$flowgrid[$flowcount][$flowmain])
			{
				$flowsub=0; $flowmain++;
				echo '</td><td valign="top" style="' . (isset($wh) ? 'width: '. $wh.'%;' : '') .  'padding-right: '.$pad.'px;">';
			}
			call_user_func($context['TPortal']['hooks']['tp_block'],$block, $theme, $side);
		}
		// according to a grid
		elseif($flow == 'grid')
		{
			echo TP_blockgrid($block, $theme, $grid_entry, $side, $grid_entry==($grid_recycle-1) ? true : false, $grid_selected);
			$grid_entry++;
			if($grid_recycle==$grid_entry)
				$grid_entry=0;
			// what if its the last block, but in the middle of the recycle?
			if($i == $n-1)
			{
				if($grid_entry>0)
				{
					for($a=$grid_entry ; $a<$grid_recycle ; $a++)
						echo TP_blockgrid(0, 0, $a, $side, $a ==($grid_recycle-1) ? true : false, $grid_selected,true);

				}
			}
		}
		// or just plain vertically
		else
			call_user_func($context['TPortal']['hooks']['tp_block'],$block, $theme, $side);
		
		$bcount++;
		$flowsub++;
	}
	if(in_array($flow, array('horiz2','horiz3','horiz4')))
		echo '</td></tr></table>';

	// the upshrink routine for blocks
	$tid=time();
	echo '</div>
			<script language="Javascript" type="text/javascript"><!--
				function toggle( targetId )
				{
					var state = 0;
					var blockname = "block" + targetId;
					var blockimage = "blockcollapse" + targetId;

					if ( document.getElementById ) {
						target = document.getElementById( blockname );
						if ( target.style.display == "none" ) {
							target.style.display = "";
							state = 1;
						}
						else {
							target.style.display = "none";
							state = 0;
						}

						document.getElementById( blockimage ).src = "'.$settings['tp_images_url'].'" + (state ? "/TPcollapse.gif" : "/TPexpand.gif");
						var tempImage = new Image();
						tempImage.src = "'.$scripturl.'?action=tpmod;upshrink=" + targetId + ";state=" + state + ";" + (new Date().getTime());

					}
				}
			--></script>';

	return $code;
}

function tp_setupUpshrinks()
{	
	global $db_prefix, $tp_prefix, $context, $scripturl,$txt , $user_info, $settings , $modSettings, $ID_MEMBER, $boarddir, $boardurl, $sourcedir;

	$tp_prefix = $settings['tp_prefix'];

	$context['tp_panels'] = array();
	if(isset($_COOKIE['tp_panels'])){
		$shrinks=explode(",",$_COOKIE['tp_panels']);
		foreach($shrinks as $sh => $val)
			$context['tp_panels'][]=$val;
	}

	// the generic panel upshrink code
	$context['html_headers'] .= '
	  <script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
		' . (sizeof($context['tp_panels'])>0 ? '
		var tpPanels = new Array(\'' . (implode("','",$context['tp_panels'])) . '\');' : '
		var tpPanels = new Array();') . '
		function togglepanel( targetID )
		{
			var pstate = 0;
			var panel = targetID;
			var img = "toggle_" + targetID;
			var ap = 0;

			if ( document.getElementById ) {
				target = document.getElementById( panel );
				if ( target.style.display == "none" ) {
					target.style.display = "";
					pstate = 1;
					removeFromArray(targetID, tpPanels);
					document.cookie="tp_panels=" + tpPanels.join(",") + "; expires=Wednesday, 01-Aug-2040 08:00:00 GMT";
					document.getElementById(img).src = \'' . $settings['tp_images_url'] . '/TPupshrink.gif\';
				}
				else {
					target.style.display = "none";
					pstate = 0;
					tpPanels.push(targetID);
					document.cookie="tp_panels=" + tpPanels.join(",") + "; expires=Wednesday, 01-Aug-2040 08:00:00 GMT";
					document.getElementById(img).src = \'' . $settings['tp_images_url'] . '/TPupshrink2.gif\';
				}
			}
		}
		function removeFromArray(value, array){
			for(var x=0;x<array.length;x++){
				if(array[x]==value){
					array.splice(x, 1);
				}
			}
			return array;
		}
		function inArray(value, array){
			for(var x=0;x<array.length;x++){
				if(array[x]==value){
					return 1;
				}
			}
			return 0;
		}
	// ]]></script>';

	$panels=array('Left','Right','Center','Top','Bottom','Lower');
	$context['TPortal']['upshrinkpanel']='';

	if($context['TPortal']['showcollapse']==1)
	{
		foreach($panels as $pa => $pan)
		{
			$side=strtolower($pan);
			if($context['TPortal'][$side.'panel']==1)
			{
				// add to the panel
				if($pan=='Left' || $pan=='Right')
					$context['TPortal']['upshrinkpanel'] .= tp_hidepanel2('tp' . strtolower($pan) . 'barHeader', 'tp' . strtolower($pan) . 'barContainer', strtolower($pan).'-tp-upshrink_description');
				else
					$context['TPortal']['upshrinkpanel'] .= tp_hidepanel2('tp' . strtolower($pan) . 'barHeader', '', strtolower($pan).'-tp-upshrink_description');
		
			}
		}
	}
	// get user values
	if($context['user']['is_logged'])
	{
		// set some values based on user-prefs
		$result =  tp_query("SELECT type,value, item FROM " . $tp_prefix . "data WHERE type=2 AND ID_MEMBER=" . $ID_MEMBER, __FILE__, __LINE__);
		if(tpdb_num_rows($result)>0)
		{
			while($row = tpdb_fetch_assoc($result))
			{
						$context['TPortal']['usersettings']['wysiwyg']=$row['value'];
			}
			tpdb_free_result($result);
		}
		if($context['TPortal']['use_wysiwyg']>0)
			$context['TPortal']['allow_wysiwyg']=true;
		else
			$context['TPortal']['allow_wysiwyg']=false;

		if(isset($context['TPortal']['usersettings']['wysiwyg']))
		{
			// if its 0 the no-one can choose it
			if($context['TPortal']['use_wysiwyg']=='0')
				$context['TPortal']['usersettings']['wysiwyg']='0';

			// check that we are not in admin section
			if((isset($_GET['action']) && $_GET['action']=='tpadmin') && ((isset($_GET['sa']) && $_GET['sa']=='settings') || !isset($_GET['sa'])))
				$in_admin=true;
			if(!isset($in_admin))
				$context['TPortal']['use_wysiwyg']=$context['TPortal']['usersettings']['wysiwyg'];
		}
	}
	// get the cookie for upshrinks
	$context['TPortal']['upshrinkblocks'] = array();
	if(isset($_COOKIE['tp-upshrinks'])){
		$shrinks=explode(",",$_COOKIE['tp-upshrinks']);
		foreach($shrinks as $sh => $val)
			$context['TPortal']['upshrinkblocks'][]=$val;
	}
	return;
}

function TP_blockgrid($block, $theme, $pos, $side, $last=false, $gridtype, $empty=false)
{
	global $context , $scripturl, $settings, $language , $txt;

	// first, set the table, equal in all grids
	if($pos==0)
		echo '<table cellpadding="0" cellspacing="0" width="100%">';

	if(isset($context['TPortal']['grid'][$gridtype][$pos]['doubleheight']))
		$dh=true;
	else
		$dh=false;

	// render if its not empty
	if(!$empty)
		echo $context['TPortal']['grid'][$gridtype][$pos]['before'] , call_user_func($context['TPortal']['hooks']['tp_block'],$block,$theme, $side,$dh) , $context['TPortal']['grid'][$gridtype][$pos]['after'];
	else
		echo $context['TPortal']['grid'][$gridtype][$pos]['before'] . '&nbsp;' . $context['TPortal']['grid'][$gridtype][$pos]['after'];

	// last..if its the last block,close the table
	if($last)
		echo '</table>';
}

function TP_blockgrids()
{
	global $context;

	$context['TPortal']['grid']=array();
	$context['TPortal']['grid']['colspan3'][0] = array('before' => '<tr><td valign="top" colspan="3" style="padding-bottom: 5px;">', 'after' => '</td></tr>');
	$context['TPortal']['grid']['colspan3'][1] = array('before' => '<td width="33%" valign="top" style="padding-right: 5px;padding-bottom: 5px;">', 'after' => '</td>');
	$context['TPortal']['grid']['colspan3'][2] = array('before' => '<td width="33%" valign="top" style="padding-right: 5px;padding-bottom: 5px;">', 'after' => '</td>');
	$context['TPortal']['grid']['colspan3'][3] = array('before' => '<td width="33%" valign="top" style="padding-bottom: 5px;">', 'after' => '</td></tr>');

	$context['TPortal']['grid']['rowspan1'][0] = array('before' => '<tr><td width="33%" valign="top" rowspan="2" style="padding-right: 5px; padding-bottom: 5px;">', 'after' => '</td>', 'doubleheight' => true);
	$context['TPortal']['grid']['rowspan1'][1] = array('before' => '<td width="33%" valign="top" style="padding-right: 5px;padding-bottom: 5px;">', 'after' => '</td>');
	$context['TPortal']['grid']['rowspan1'][2] = array('before' => '<td width="33%" valign="top" style="padding-bottom: 5px;">', 'after' => '</td></tr>');
	$context['TPortal']['grid']['rowspan1'][3] = array('before' => '<tr><td width="33%" valign="top" style="padding-right: 5px;padding-bottom: 5px;">', 'after' => '</td>');
	$context['TPortal']['grid']['rowspan1'][4] = array('before' => '<td width="33%" valign="top" style="padding-bottom: 5px;">', 'after' => '</td></tr>');
}

function doModules() {
	global $context, $boarddir, $tp_prefix;
    
    // fetch any block render hooks and notifications from tpmodules
	$context['TPortal']['tpmodules'] = array(
		'blockrender' => array(),
		'adminhook' => array(),
		'frontsection' => array(),
		'globaltag' => array(),
		);
	$context['TPortal']['modulepermissions'] = array('tp_settings','tp_blocks','tp_articles','tp_alwaysapproved','tp_submithtml','tp_submitbbc','tp_editownarticle');

	$request =  tp_query("SELECT id,modulename,blockrender,autoload_run,adminhook, frontsection,permissions,globaltags FROM " . $tp_prefix . "modules WHERE active=1", __FILE__, __LINE__);
	if(tpdb_num_rows($request)>0)
	{
		while($row=tpdb_fetch_assoc($request))
		{
			if(!empty($row['permissions']))
			{
				$all = explode(",",$row['permissions']);
				foreach($all as $one)
				{
					$real = explode("|",$one);
					$context['TPortal']['modulepermissions'][] = $real[0];
					unset($real);
				}
			}
			if(!empty($row['blockrender']))
				$context['TPortal']['tpmodules']['blockrender'][$row['id']] = array(
						'id' => $row['id'],
						'name' => $row['modulename'],
						'function' => $row['blockrender'],
						'sourcefile' => $boarddir .'/tp-files/tp-modules/' . $row['modulename']. '/Sources/'. $row['autoload_run'],
				);
			if(!empty($row['frontsection']))
				$context['TPortal']['tpmodules']['frontsection'][$row['id']] = array(
						'id' => $row['id'],
						'name' => $row['modulename'],
						'function' => $row['frontsection'],
						'sourcefile' => $boarddir .'/tp-files/tp-modules/' . $row['modulename']. '/Sources/'. $row['autoload_run'],
					);
			if(!empty($row['globaltags']))
				$context['TPortal']['tpmodules']['globaltags'][$row['id']] = array(
						'id' => $row['id'],
						'name' => $row['modulename'],
						'function' => $row['globaltags'],
						'sourcefile' => $boarddir .'/tp-files/tp-modules/' . $row['modulename']. '/Sources/'. $row['autoload_run'],
					);
		}
		if(file_exists($boarddir .'/tp-files/tp-modules/' . $row['modulename']. '/Sources/'. $row['autoload_run']))
		{
			if(!empty($row['adminhook']))
			{
				$perms=explode(",", $row['permissions']);
				for($a=0 ; $a < sizeof($perms) ; $a++)
				{
					$pr=explode("|",$perms[$a]);
					// admin permission?
					if($pr[1]==1)
					{
						if (allowedTo($pr[0]))
						{
							require_once($boarddir .'/tp-files/tp-modules/' . $row['modulename']. '/Sources/'. $row['autoload_run']);
							$context['TPortal']['tpmodules']['adminhook'][$row['id']] = call_user_func($row['adminhook']);
						}
					}
				}
			}
		}
		tpdb_free_result($request);
	}    
}

// TPortal leftblocks
function TPortal_leftbar()
{
	TPortal_sidebar('left');
}

// TPortal centerbar
function TPortal_centerbar()
{
	TPortal_sidebar('center');
}

// TPortal rightbar
function TPortal_rightbar()
{
	TPortal_sidebar('right');
}
// compability
if(!function_exists('doUBBC'))
{
	function doUBBC($code)
	{
		parse_bbc($code);
	}
}
if(!function_exists('db_query'))
{
	function db_query($code)
	{
		tp_query($code);
	}
}
?>